plotErrors = function(inFiles,outFile) {

  bdys = c(0,scan("mafUpperLimits.txt"))

  pdf(outFile)

  #par(cex=0.8)
  par(xaxs='i',yaxs='i')

  # x = 0, 2, ..., 22 is for tick marks showing MAF bin boundaries.
  # x = 1, 3, ..., 21 is for data points.
  
  xMax = 2*(length(bdys)-1) # e.g. 22
  plot(c(0,xMax),
       c(0,16000),
       type='n',
       xaxt = 'n',
       xlab = '',
       ylab = '')

  axis(1, at = 2*(1:length(bdys)-1), labels=bdys, las=2)

  syms = c("o","+","o","+")
  cols = c(1,2,1,2)
  for (i in 1:length(inFiles)) {
    v=scan(inFiles[i])
    if (i>2) lt=2
      else lt=1
    lines(2*(1:length(v))-1,v,col=cols[i],type="b",pch=syms[i],lty=lt)
  }
  
  dev.off()
}

plotErrors(c("abi_i_mf","sol_i_mf"), "i_errs.pdf")
plotErrors(c("abi_c_mf","sol_c_mf","abi_c_null","sol_c_null"), "c_errs.pdf")

