plotErrors = function(inFiles) { # ,outFile) {

  #pdf(outFile)

  par(cex=0.5)
  par(xaxs='i',yaxs='i')
  plot(c(0,1.01),
       c(0.000001,1),
       type='n',
       #xaxt = 'n',
       xlab = '',
       ylab = '',
       log = "y")
  col = c(1,1,1,2,1,2)
  syms = c('*','x','+','o',' ',' ')
  for (i in 1:length(inFiles)) {
    t=read.table(inFiles[i])
    lines(t,col=col[i])
    points(t,col=col[i],pch=syms[i])
  }

  legend(0.1,0.0001,"Star",pch="*",bty='n',col=col[1])
  legend(0.1,0.00005,"Window",pch="x",bty='n',col=col[2])
  legend(0.1,0.000025,"MF",pch="+",bty='n',col=col[3])
  legend(0.1,0.0000125,"MF-Illumina",pch="o",bty='n',col=col[4])
  
  #dev.off()
}

plotCumul = function(inFiles,outFile) {

  pdf(outFile)

  #par(cex=0.8)
  par(xaxs='i',yaxs='i')
  plot(c(0,1.01),
       c(0,4000),
       type='n',
       #xaxt = 'n',
       xlab = '',
       ylab = '')
  col = c(1,1,1,2,1,2)
  syms = c('*','x','+','o',' ',' ')
  for (i in 1:length(inFiles)) {
    t=read.table(inFiles[i])
    lines(t,col=col[i])
    points(t,col=col[i],pch=syms[i])
  }

  legend(0.1,3500,"Illumina",pch="x",bty='n')
  legend(0.1,3000,"ABI",pch="*",bty='n')
  
  dev.off()
}

pdf("figure2.pdf")
# This allows 2 x 2 plots on the page. We only need 2, but this is a convenient
# way of just using the top half of the page.
par(mfrow=c(2,2))
plotErrors(c("rates_star_c","rates_win_c","rates_mf_c","rates_mfsol_c","rates_null_c","rates_nullsol_c"))
plotErrors(c("rates_star_i","rates_win_i","rates_mf_i","rates_mfsol_i"))
dev.off()

# Not needed for the paper:
#plotCumul(c("cumul_mf_c","cumul_mfsol_c"),"cumul_c.pdf")
#plotCumul(c("cumul_mf_i","cumul_mfsol_i"),"cumul_i.pdf")
