t = read.table("csi_y.txt")

pdf("indels.pdf")

sz = 12162996

t$V2 = t$V2/sz
t$V3 = t$V3/sz

mx = max(t$V2,t$V3)*1.1

par(cex=0.75)

plot(t$V2,t$V3,xlim=c(0,mx),ylim=c(0,mx),xlab="Insertions (proportion of genome)",ylab="Deletions (proportion of genome)")

title("Insertions and deletions for S cerevisiae strains","Figure produced by bin/indels.R")

abline(0,1)

# We could do text(t$V2,t$V3,t$V1,pos=1) to annotate under everything, but
# then we'd get overlaps...

u = subset(t,V1 %in% c("S288c","W303","MRCA"))
text(u$V2,u$V3,u$V1,pos=1)
#,"NCYC110","Y55","DBVPG6044","SK1"))  
x = t$V2[t$V1 == "NCYC110"]
y = t$V3[t$V1 == "NCYC110"]
d = y/20

ncyc = (t$V1 == "NCYC110")
text(t$V2[ncyc],t$V3[ncyc],"NCYC110",pos=3)
y55 = (t$V1 == "Y55")
text(t$V2[y55],t$V3[y55],"Y55",pos=1)
db44 = (t$V1 == "DBVPG6044")
text(t$V2[db44],t$V3[db44]*0.95,"DB'6044",pos=4)
sk1 = (t$V1 == "SK1")
text(t$V2[sk1],t$V3[sk1],"SK1",pos=4)


