t <- read.table("summary_lib.txt",header=T)

pMap = t$n_mapped / t$n_reads

pPair = t$n_paired / t$n_mapped

wantSC = pPair>0 & substr(t$lib,4,5) == "SC"

anno = wantSC & (pMap < 0.95 | pPair < 0.9)

pdf("readProps.pdf")
plot(pMap[wantSC],pPair[wantSC],col=1,
     main="plotSummaryLib.R",
     xlab="Proportion of reads mapped",
     ylab="Proportion of mapped reads mapped in pairs")

posn = pMap
posn[pMap >= 0.85] = 2
posn[pMap < 0.85] = 4
text(pMap[anno],pPair[anno],labels=substr(t$lib[anno],7,16),cex=0.7,pos=posn[anno])
dev.off()

pdf("readRates.pdf")

plot(t$dup_rate,t$err_rate,
     main="plotSummaryLib.R",
     ylab="Error rate",
     xlab="Duplication rate")

anno = substr(t$lib,4,5) == "SC" & (t$err_rate >= 0.04 | t$dup_rate > 0.05)
text(t$dup_rate[anno],t$err_rate[anno],labels=t$lib[anno],cex=0.7,pos=4)

dev.off()
