// Non-nested function is static anyway:
int foo(int i) {
  return i*i;
}

class C {
  int member(int i) {
    return i+i;
  }
}

void main() {

  // Pointer to static function
  int function(int) fp;
  fp = &foo;
  printf("fun 1 = %2d\n",fp(1));

  // Nested function is in context of main,
  // so non-static unless we say static:
  static int bar(int i) {
    return i+i;
  }
  printFun(&bar,2);
  //fp = &bar;
  //printf("fp 2 = %2d\n",fp(2));

  // This one is non-static, so we set a delegate
  // to it, not a function (pointer).
  int foo2(int i) {
    return i*4;
  }
  int delegate(int) del = &foo2;
  printf("del 3 = %2d\n",del(3));

  // Unnamed delegate, taking an int argument
  del = (int i) {return i*i*i;};
  printDel(del,4);
  // Or alternatively:
  printDel((int i) {return i*i*i;},4);

  // Delegate to member function of instance
  auto c = new C;
  printDel(&c.member,5);
  // Or alternatively:
  //del = &c.member;
  //printf("del 3 = %2d\n",del(3));
}

void printFun(int function(int) fun, int i) {
  printf("fun %d = %2d\n",i,fun(i));
}

void printDel(int delegate(int) del, int i) {
  printf("del %d = %2d\n",i,del(i));
}
