import std.stdio;

void main() {
  int[char[]] h;
  h["zero"] = 0;
  h["one"] = 1;
  h["two"] = 2;
  h["three"] = 3;
  // Can index on values or on keys and values:
  foreach (int n ; h) {
    writefln("%d",n);
  }
  foreach (char[] word, int n ; h) {
    writefln("%5s = %d",word,n);
  }
  writefln();
  // And the same for ordinary arrays:
  char[][] a = ["zero","one","two","three"];
  foreach (char[] word ; a) {
    writefln("%5s",word);
  }
  // Try modifying the values; need inout:
  foreach (inout char[] word; a) {
    word = word ~ " " ~ word;
  }
  foreach (char[] word ; a) {
    writefln("%5s",word);
  }
  // Can do reverse order for ordinary (not associative) arrays:
  foreach_reverse (int n, char[] word ; a) {
    writefln("%5s = %d",word,n);
  }
  // Chars of strings:
  foreach (char c ; "hello") {
    printf("%c\n",c);
  }
}
