// Use of opApply to allow foreach over classes.

class C {

  double array[2];

  // Allow foreach(double d; c):
  int opApply(int delegate(inout double) del) {
    // We need "inout" here to make altering values work:
    foreach (inout double v; array) {
      if (int res = del(v)) return res;
    }
    //for (int i=0; i<array.length; i++) {
    //  if (int res = del(array[i])) return res;
    //}
    return 0;
  }

  // allow foreach(int i, double d; c):
  int opApply(int delegate(inout int, inout double) del) {
    foreach (int i, double v; array) {
      if (int res = del(i,v)) return res;
    }
    return 0;
  }

  // Defining opApplyReverse would set up foreach_reverse.
}

void main() {
  C c = new C;
  c.array[0] = 3.1;
  c.array[1] = 6.2;
  foreach (double d ; c) {
    printf("%3.1f\n",d);
  }
  foreach (inout double d ; c) {
    d ++;
  }
  foreach (int i, double d ; c) {
    printf("%d: %3.1f\n",i,d);
  }
}
