void main() {

  int[] a = [2,4,6,8];
  report(a); // 2468
  report(a[1 .. 3]); // 46
  a[1 .. 3].report(); // alternative syntax; must have ()
  report(a ~ 9); // 24689

  int[] b = [1,3,5,7];
  report(a ~ b); // 24681357

  int[] c = a[1 .. 3];
  c[0] = 0;
  report(a); // 2068 because c is part of a

  int[] d = a[1 .. 3] ~ 9;
  d[1] = 0;
  // Still 2068 because '~' caused a[1..3] to be copied
  report(a);

  // $ can be used for length inside array args, but can't
  // say "e.$"
  int[] e = a[2 .. $];
  report(e);
  
}

void report(int[] a) {
  foreach(n ; a) printf("%d",n);
  printf("\n");
}
