struct Quad { int a; int b; int c=3; int d=7;};

void main(char[][] argv) {
  // Can only initialize like this if static, and
  // then can only use constant (compile-time) values:
  static Quad q1 = {a:1, c:3};
  printf("q1 = %d %d %d %d\n",q1.a,q1.b,q1.c,q1.d);
  Quad q2;
  q2.a = 1;
  q2.c = 4;
  printf("q2 = %d %d %d %d\n",q2.a,q2.b,q2.c,q2.d);
  // Position-based initialization:
  static Quad q3 = { 1,2,3,4 };
  printf("q3 = %d %d %d %d\n",q3.a,q3.b,q3.c,q3.d);
  printf("Size of Quad is %d\n",Quad.sizeof);
  // Try and return one from a function; seems to work,
  // by making a copy (since we can change it, and the
  // static one returns the original value):
  Quad q4 = foo();
  printf("q4 = %d %d %d %d\n",q4.a,q4.b,q4.c,q4.d);
  q4.d = 8;
  Quad q5 = foo();
  printf("q5 = %d %d %d %d\n",q5.a,q5.b,q5.c,q5.d);
}

Quad foo() {
  static Quad q; // static not essential here
  q.a = 5;
  q.b = 6;
  return q;
}

