// Static initializers and destructors

class A {

  static this() {
    printf("Static this of A\n");
  }
  
  static ~this() {
    printf("Static ~this of A\n");
  }

  this() {
    printf("Normal this of A\n");
  }

  ~this() {
    printf("Normal ~this of A\n");
  }

}

class B {

  static this() {
    printf("Static this of B\n");
  }
  
  static ~this() {
    printf("Static ~this of B\n");
  }

  this() {
    printf("Normal this of B\n");
  }

  ~this() {
    printf("Normal ~this of B\n");
  }

}

void main() {
  printf("Started main\n");
  // a gets destructed immediately main finishes,
  // but b has to wait for the GC, which appears to
  // run after the static destructors.
  scope A a = new A;
  B b = new B;
  printf("Finished main\n");
}

