// Variadic functions: ordinary (foo) and type safe (sum).
// Also use of typesafe to construct object on fly.

// Type safe are easier to use, but all the variadic args
// must be same type.

import std.stdio;

class Foo {
  int i_;
  char[] s_;
  this(int i, char[] s) {
    i_ = i;
    s_ = s;
  }
}

void main() {
  foo(3,4,5.0,6);
  const int isz = 10;
  int[isz] ii;
  for (int i=0; i<ii.length; i++)
    ii[i] = i+1;
  writefln("Sum of 1 to %d = %d",isz,sum(ii));
  writefln("Sum of 1 to 3 = %d",sum(1,2,3));
  // Can hand constructor args for (one) variadic class param:
  bar(3,"hello");
  baz(1,25,{writefln("cheers"); return 4;});
}

void foo(int x, ...) {
  writefln("x = %d",x);
  void* ptr = _argptr;
  for (int i=0; i<_arguments.length; i++) {
    TypeInfo ty = _arguments[i];
    if (ty == typeid(int)) {
      int k = *(cast(int*) ptr);
      writefln("Arg %d is %d",i,k);
      ptr += int.sizeof;
    } else if (ty == typeid(double)) {
      double z = *(cast(double*) ptr);
      writefln("Arg %d is %5.3f",i,z);
      ptr += double.sizeof;
    } else {
      writefln("Arg %d is not an int or a double",i);
      return;
    }
  }
}

int sum(int[] ar ...) {
  int s = 0;
  foreach (int v ; ar) {
    s += v;
  }
  return s;
}

void bar(Foo f ...) {
  writefln("Foo %d %s",f.i_,f.s_);
}

// This trick only works with array of delegates of no args
// (but can have any fixed return type):
void baz(int delegate()[] dgs ...) {
  foreach (dg ; dgs) {
    writefln("dg returns %d",dg());
  }
}
