module tally;

import std.string;
import std.c.math;

class Tally {

private:

  double min,max,sum1,sum2;
  int count;


public:

  this(double v) {
    count = 1;
    min = max = sum1 = v;
    sum2 = v*v;
  }

  void add(double v) {
    if (min > v) min = v;
    if (max < v) max = v;
    count ++;
    sum1 += v;
    sum2 += v*v;
  }

  double mean() {
    return sum1/count;
  }

  // Biased variance
  double variance() {
    if (count > 1) {
      double mu = mean();
      return sum2/count-mu*mu;
    } else {
      return 0.0; // by definition
    }
  }
  
  double sd() {
    return sqrt(variance());
  }

  char[] toString() {
    return format("%3d %-+#12.8g %-+#12.8g %-+#12.8g %-+#12.8g",
		  count,mean(),sd(),min,max);
  }

}
  
