import Data.Array.IArray
import Data.List

-- Helpers to construct arrays
-- mapRange f lo hi = [f i | i <- range (lo,hi)]
mapRange f lo hi = map f (range (lo,hi))

mapRangePairs f lo hi = [(i,f i) | i <- range (lo,hi)]

mapIndex f i [] = []
mapIndex f i (h:t) = f i h : mapIndex f (succ i) t

mapIndexPairs f i [] = []
mapIndexPairs f i (h:t) = (i, f i h) : mapIndexPairs f (succ i) t

square x = x*x

-- We need this declaration so the range has a good type:
arr1 :: Array Integer Integer
arr1 = array (1,10) $ mapRangePairs square 1 10

-- listArray will create the indices for us
arr2 :: Array Integer Integer
arr2 = listArray (1,10) $ mapRange square 1 10

-- accumArray combines values with same key, and uses a
-- default when no occurrences
pairs = mapRangePairs square 2 4 ++ mapRangePairs square 4 6
arr3 :: Array Integer Integer
arr3 = accumArray (+) 0 (1,10) pairs

-- These are equivalent:
pairs2a = assocs arr3
pairs2b = zip (indices arr3) (elems arr3)

-- Updated array:
ttft = [(2,10),(4,10)]
arr4 = arr3 // ttft
-- Accumulating update:
arr5 = accum (+) arr3 ttft

-- Apply function to each element:
arr6 = amap square arr5

-- Equivalent, but for indices. Note the function
-- returns the index to use to access the input array.
arr7 = ixmap (0,9) (+1) arr5