import System (getArgs)
import System.Console.GetOpt
import qualified Data.Map as DM

main = getArgs

stringToInt :: String -> Int
stringToInt s =
   case reads s
   of [(v,"")] -> v
      _ -> 0

optDescrList = [Option "nN" ["number"] (ReqArg id "COUNT") "count"]

-- Note small "o" here...
getopt :: [Char] -> [String] -> (DM.Map [Char] String, [String], [String])
getopt spec args = 
    let optDescrList = convertOptionSpec spec
        (pairs,rest,errs) = getOpt RequireOrder optDescrList args
    in (DM.fromList pairs,rest,errs)

-- Convert Perl Getopt-style spec into Haskell spec

convertOptionSpec [] = []
convertOptionSpec (c:':':spec) =
    let opt = Option [c] [[c]] (ReqArg (\x -> ([c],x)) [c]) [c]
    in opt : convertOptionSpec spec
convertOptionSpec (c:spec) =
    let opt = Option [c] [[c]] (NoArg ([c],"")) [c]
    in opt : convertOptionSpec spec
