import Control.Monad

-- Define some actions
a = putStrLn "AAA"
b = putStrLn "BBB"
c = putStrLn "CCC"

-- Can't do this because types are different:
-- IO () and IO String
-- a2 = sequence [ a, return "a2"]

-- These are equivalent:
act0a = mapM_ putStr ["abc","def"]
act0b = forM_ ["abc","def"] putStr 

-- So are these
act1a = mapM putStr ["abc","def"]
act1b = forM ["abc","def"] putStr 

act2 = sequence [a,b]

act3 = sequence_ [a,b]

act4 = return "act4" >>= putStrLn

act5a = getLine >>= putStrLn
act5b = putStrLn =<< getLine

twice x = [x,x]

four x = twice x >>= twice

-- Can't find >=>, despite documentation

(>=>) f1 f2 x = f1 x >>= f2 
(<=<) f2 f1 x = f1 x >>= f2 
-- Example use:
fourk = twice >=> twice

forever act = do {act; forever act}

-- Generalization of concat:
just1 = msum [Just 1, Just 2]
just2 = msum [Nothing, Just 2]
nowt1  = msum [Nothing, Nothing]
l123 = msum [[1],[2,3]]

-- Remove a level of monads:
just3 = join (Just (Just 3))
nowt2 = join (Just Nothing)

vowelPat str = map ((flip elem) "aeiou") str
mystery = filterM vowelPat ["aa","b"]

f2 x y = [x+y,x-y,x*y]

putAnd x y = putStrLn $ x ++ " and " ++ y
-- Prints "a and c", then prints "b and d"
act6 = zipWithM putAnd ["a","b"] ["c","d"]

lst2 = zipWithM f2 [10,15] [30,40]
{- The above gives:
[[40,55],    -- 10+30 and 15+40
 [40,-25],   -- 10+30 and 15-40
 [40,600],   -- 10+30 and 15*40
 [-20,55],   -- 10-30 and 15+40
 [-20,-25],  -- 10-30 and 15-40
 [-20,600],  -- 10-30 and 15*40
 [300,55],   -- 10*30 and 15+40
 [300,-25],  -- 10*30 and 15-40
 [300,600]]  -- 10*30 and 15*40
-}

-- mapAndUnzipM -- find a use for this!

appendBothWays a b = [a++b,b++a]
--  fwd fwd   fwd rev  rev fwd rev rev
-- ["123456","561234","341256","563412"]
perms = foldM appendBothWays "12" ["34","56"]

-- Print AAA four times
rep1 = replicateM 4 a
-- Ditto but discard result
rep2 = replicateM_ 4 a

guard1 :: Maybe ()
guard1 = guard True

guard2 :: [()]
guard2 = guard True

-- guard3 :: IO () -- fails

amight b = when b a
amightnot b = unless b a

-- All three successors: 2,3,4
l3 = (liftM succ) [1,2,3]
-- All nine pairwise sums
l9 = (liftM2 (+)) [1,2,3] [10,20,30]
-- All 27 3-way sums
add3 x y z = x+y+z
l27 = (liftM3 add3) [1,2,3] [10,20,30] [100,200,300]
-- Equivalent to l9
l9b = return (+) `ap` [1,2,3] `ap` [10,20,30]
-- Equivalent to l27
l27b = return add3 `ap` [1,2,3] `ap` [10,20,30] `ap` [100,200,300]