import Data.Sequence (Seq,(<|),(|>),(><))
import qualified Data.Sequence as DS

import Data.Foldable -- for toList
import Data.Array (range) -- for range

-- Differ from lists in being strict, finite, and having
-- a wider range of operations. More like perl lists/arrays?
-- But NOT so good for iterating through (no map, etc)

abc = DS.fromList "abc"
labc = toList abc

-- Element adders: point towards new element
dabc = 'd' <| abc
abcd = abc |> 'd'
-- Append
dd = dabc >< abcd

-- Head and tail, using views; fails on empty.
shead s = let (DS.:<) h t = DS.viewl s
          in h
stail s = let (DS.:<) _ t = DS.viewl s
          in t
sinit s = let (DS.:>) h t = DS.viewr s
          in h
slast s = let (DS.:>) h t = DS.viewr s
          in t

ab = sinit abc

b = DS.index dd 5

dxd = DS.update 4 'x' dd

d2x = DS.take 5 dxd

rev = DS.reverse dd

-- Start before 'a' so element 0 is backtick, 1 is a, etc.
az = DS.fromList $ range (pred 'a','z')

subseq start len seq = DS.drop start $ DS.take (start+len) seq

mn = subseq 13 2 az
