module Maqqual where

depfac k = 0.8 ^ k

-- Eqn 4

alphaBar :: Integer -> Integer -> Double -> Double
alphaBar n k ebar = exp $ logAlphaBar n k ebar
                    
logAlphaBar :: Integer -> Integer -> Double -> Double
logAlphaBar n k ebar =
    let lcnk = log $ (fromInteger $ choose n k)
        tk = (fromInteger k) * log ebar
        tnk = fromInteger (n-k) * log (1-ebar)
    in lcnk + tk + tnk

choose :: Integer -> Integer -> Integer
choose n k =
    let i = min k (n-k)
    in choose1 n i

choose1 :: Integer -> Integer -> Integer
choose1 n 0 = 1
choose1 n i = ((choose1 (n-1) (i-1))*n) `div` i

-- Eqn 5
betaBar :: Integer -> Integer -> Double -> Double
betaBar n k ebar = 
    if k >= n
    then 0
    else let den = 1 - sumAlphaBar n (k-1) ebar
             num = den - alphaBar n k ebar
         in num/den
           
sumAlphaBar n k ebar =
  if k < 0
  then 0
  else alphaBar n k ebar + sumAlphaBar n (k-1) ebar

pow x y = exp $ y * log x

--c :: Integer -> Integer -> Double -> Double
c n k ebar = 
    let lhs = 1 - pow (betaBar n k ebar) (depfac k)
        rhs = cRhs n (k-1) ebar
    in lhs / rhs

cRhs n k ebar =
    if k < 0
    then 1
    else 
        let p = pow (betaBar n k ebar / ebar) (depfac k)
        in p * cRhs n (k-1) ebar

