module Main where

import Data.Array.IO
import Control.Monad

import Data.List

n = 10000000

-- From Haskell-Cafe, 8 Nov 2007

-- Dan Piponi's slow solution:

mainSlow = do
   a <- newArray (0,n-1) 1.0 :: IO (IOUArray Int Double)
   forM_ [0..n-2] $ \i -> do x <- readArray a i
                             y <- readArray a (i+1)
                             writeArray a (i+1) (x+y)
   x <- readArray a (n-1)
   print x


-- Mikhail Gusarov's fast solution:
sumint1 = foldl' (+) 0 $ take n [1.0,1.0..]

mainFast = do let v = sumint1
              putStrLn (show v)

main = mainFast

-- This solution is slow because of the recursion
sumint2 = sumint2b n 0

sumint2b 0 sum = sum
sumint2b n sofar = sumint2b (n-1) (n+sofar+1)

