module Main where

import Data.Array as DA

data Tree a = Leaf a | Branch (Tree a) (Tree a)
  deriving (Eq,Ord,Show)

instance Functor Tree where
  fmap = treeMap

treeMap f (Leaf x) = Leaf (f x)
treeMap f (Branch t1 t2) = Branch (treeMap f t1) (treeMap f t2)

t = Branch (Leaf 1) (Leaf 3)
t10 = fmap (*10) t

a = DA.listArray (1,3) [3,4,5]
a10 = fmap (*10) a

j = Just 6
j10 = fmap (*10) j

doMaybe = do x <- (Just 6)
             let y8 = x+2
             y24 <- just4Times x
             return (y8,y24)

just4Times x = Just (4*x)

doList = do x <- [1,2,3]
            --let y = x+2
            y <- [x,-x]
            return y
