-- same as foldr:
reduce f x [] = x
reduce f x (a:l) = f a $ reduce f x l

my_sum = reduce (+) 0
my_product = reduce (*) 1

anytrue = reduce (||) False
alltrue = reduce (&&) True

swap f a b = f b a

-- append a b = reduce (:) b a
append = swap (reduce (:))

doubleall = map (2*)

summatrix = my_sum . map my_sum

----------------------------------

data Tree a = Term a | NT (Tree a) (Tree a)
     deriving (Show, Eq, Ord)

-- redtree (+0) (+) (NT (Term 2) (Term 3))
redtree f g (Term x) = f x
redtree f g (NT t1 t2) = g (redtree f g t1) (redtree f g t2)

-- apptree (\x -> x*x) (NT (Term 2) (Term 3))
apptree f (Term x) = Term (f x)
apptree f (NT t1 t2) = NT (apptree f t1) (apptree f t2)

----------------------------------

sqrt_approx n x = (x+n/x)/2

-- take 10 (repap (sqrt_approx 3) 2)
repap f a = a:(repap f (f a))

-- within 0.0000001 (repap (sqrt_approx 3) 2)

-- il is an infinite list but it works...
-- let il = (repap (sqrt_approx 3) 2) in within 0.001 il

within eps (a:(b:t))
   | abs(b-a) <= eps = a
   | otherwise      = within eps (b:t)

-- "within 0" is perhaps risky, but ...
my_sqrt x | x > 0 = within 0 (repap (sqrt_approx x) 1)
