module Array where

import Data.Array as DA

import Data.Sequence as DS

-- List comprehension:
sql = [(i,i*i) | i<-[1..10]]

-- Array from that list of pairs:
sqa = array (1,Prelude.length sql) sql

-- Array of factorials, from bounds and list of (index,value) pairs.
-- OK to be recursive because non-strict.
a = array (1,100) ((1,1) : [(i, i * a!(i-1)) | i <- [2..100]])

-- Array from list
la = listArray (1,10) [11..20]

-- Accumulating array: use arg1 as func to combine values of repeated
-- indices. Strict if arg1 is strict, so then can't be recursive defn.
-- Result is fourth powers.
aa = accumArray (*) 1 (1,10) (concat [sql,sql])

-- sqa2!i = sqa!(i+2)
sqa2 = ixmap (-1,8) (2+) sqa

-- Accessors:
--  sqa!3
--  bounds sqa
--  indices sqa
--  elems sqs
--  assocs sqa

-- Incremental updates
sqa1 = sqa // [(1,1),(2,2)]

-- Result is 6th powers: accumulate array with extra list
aa2 = accum (*) aa sql
