import System (getArgs)
import Perl2HS
import Utility

--  ghc --make expandNamesInTree.hs -o expandNamesInTree

main = do
  args <- getArgs
  mapM_ expandNamesInTree args

expandNamesInTree key = do
  let ftFile = key ++ ".fulltree"
  let sFile  = key ++ ".strains"
  let tFile  = key ++ ".tree"
  ok <- existenceOK [sFile,tFile] [ftFile]
  if ok
   then expandNamesInTree1 sFile tFile ftFile
   else return ()

expandNamesInTree1 sFile tFile ftFile = do
  strains <- linesInFile sFile
  tLines <- linesInFile tFile
  putStrLn $ "Creating: " ++ ftFile
  writeFile ftFile $ expandNamesInLines strains tLines
  return ()

expandNamesInLines strains tLines = 
   unlines $ map (expandNamesInLine strains) tLines

expandNamesInLine strains (ch:':':rest) =
   expandName strains ch ++ (':':rest)
expandNamesInLine _ line = line

expandName strains ch = strains !! charIndex ch

charIndex ch | (ch >= 'A' && ch <= 'Z') = fromEnum ch - fromEnum 'A'
charIndex ch | (ch >= 'a' && ch <= 'z') = fromEnum ch - fromEnum 'a' + 26


