import qualified Data.Char as DC 

type RSLPair a = ([a],String)

-- Call as e.g. ReadSomeList "10.1 12.2 xyz" :: RSLPair Float
ReadSomeList :: (Read a) => String -> RSLPair a

ReadSomeList str =
  case reads str of
    [(val,rest)] -> 
       let (vals,rem) = ReadSomeList rest
       in (val:vals,rem)
    _ -> ([],dropWhile DC.isSpace str)

readIntList     = ReadSomeList :: String -> RSLPair Int
readIntegerList = ReadSomeList :: String -> RSLPair Integer
readFloatList   = ReadSomeList :: String -> RSLPair Float
readDoubleList  = ReadSomeList :: String -> RSLPair Double
