package UsageList;

use Exporter;
@ISA = qw(Exporter);
@EXPORT = qw(usageList);

use Utility;
use Cwd;
use strict;

sub usageList {
    my ($wantAll,@topFiles) = @_;
    my @relInc;
    my $cwd = cwd();
    my $lcwd = length($cwd);
    my $home = $ENV{'HOME'};
    my $lhome = length($home);
    foreach my $d (@INC) {
	if (substr($d,0,$lcwd) eq $cwd) {
	    $d = substr($d,$lcwd);
	    $d =~ s/^\///;
	} elsif ($d =~ /^\// && substr($d,0,$lhome) ne $home && !$wantAll) {
	    next;
	}
	push @relInc,$d;
    }
    my %use;
    foreach my $f (@topFiles) {
	noteFile($f,\%use,\@relInc);
    }
    return sort keys %use;
}

sub noteFile {
    my ($f,$pUse,$pRelInc) = @_;
    if (my $full = `which $f 2>/dev/null`) {
	chomp $full;
	$f = $full;
    }
    my $cwd = cwd();
    my $lcwd = length($cwd);
    if (substr($f,0,$lcwd) eq $cwd) {
	$f = substr($f,$lcwd);
	$f =~ s/^\///;
    }
    $f =~ s/^\.\///;
    return if ($pUse->{$f});
    die("Missing or empty: $f") unless (-s $f);
    return if (defined $pUse->{$f}); # avoid loops
    $pUse->{$f} = 1;
    my $fh = openToRead($f);
    while (<$fh>) {
	if (/^use\s+(\S*)\s*;/) {
	    noteModule($1,$pUse,$pRelInc);
	} elsif (/([a-zA-Z0-9_]+\.pl)/) {
	    noteFile($f,$pUse,$pRelInc);
	}
    }
}

sub noteModule {
    my ($m,$pUse,$pRelInc) = @_;
    my $b = "$m.pm";
    $b =~ s/::/\//g;
    foreach my $dir (@$pRelInc) {
	my $f = "$dir/$b";
	if (-s $f) {
	    noteFile($f,$pUse,$pRelInc);
	    last;
	}
    }
}

1;
