#!/usr/bin/env perl

# See th/0327

use Utility;
use strict;

#my $SUB = 0.00074; # or 0.74 if multiplied up by 1000
# Adjustment seems no longer necessary, now we handle
# Solexa qualities properly. 15-2-08.
my $SUB = 0; # 0.00074; # or 0.74 if multiplied up by 1000

my ($sFile,$mFile) = @ARGV;

my %isSol = map {$_ => 1} qw(Q31_4 Q69_8 Q74_4 Y8_1 Y8_5 Y9_6 W7 Z1);

my %solPos;
my $fh = openToRead($sFile);
my $pos = 0;
while (<$fh>) {
    chomp;
    $solPos{$pos} = 1 if ($isSol{$_});
    $pos ++;
}

my $fh = openToRead($mFile);
my $row = 0;
while (<$fh>) {
    chomp;
    my @a = split;
    my $solRow = $solPos{$row};
    if ($solRow) {
	foreach my $col (0 .. $#a) {
	    $a[$col] -= $SUB unless ($col == $row);
	}
    }
    foreach my $col (keys %solPos) {
	$a[$col] -= $SUB unless ($col == $row);
    }
    my $sep = '';
    foreach my $d (@a) {
	printf("%s%8.6f",$sep,$d);
	$sep = ' ';
    }
    print "\n";
    $row ++;
}
