#!/usr/bin/env perl

use Utility;
use strict;

foreach my $s (@ARGV) {
    my $f = "$s/cere.sv2/ssahaSNP.all.gz";
    my $g = "$s/cere/ssahaSNP.all.gz";
    if (-s $f && stamp($g)) {
	report("$g: creating");
	adjustSsahaSNPScores(openToRead($f),openToWrite($g));
	report();
	unstamp($g);
    }
}

sub adjustSsahaSNPScores {
    my ($fh,$gh) = @_;
    my $active = 1;
    while (<$fh>) {
	if (/^ALIGNMENT/) {
	    my @a = split;
	    my $adj = 3*$a[1]-2*$a[9];
	    $active = ($adj > 0);
	    if ($active) {
		my $padded = (' ' x (length($a[1])-length($adj))) . $adj;
		s/$a[1]/$padded/; # should work as early in line and no funny chars!
	    }
	} elsif (/^=/) {
	    $active = 1;
	}
	print $gh $_ if ($active);
    }
}
