#!/usr/bin/env perl

use Utility;
use Getopt::Std;
use strict;

my %OPT;
getopts('h',\%OPT);

my @lines;
my @maxLen;
my @hdr = (' ',qw(Score Query Sbjct QLo QHi SLo SHi Ori ALen PercI QLen));
if ($OPT{h}) {
    foreach my $i (0 .. $#hdr) {
	$maxLen[$i] = length($hdr[$i]);
    }
}
while (<>) {
    chomp;
    if (/^ALIGNMENT/) {
	my @a = split;
	push @lines,\@a;
	foreach my $i (0 .. $#a) {
	    $maxLen[$i] = max($maxLen[$i],length($a[$i]));
	}
    }
}
if ($OPT{h}) {
    unshift @lines,\@hdr;
}
foreach my $pA (@lines) {
    foreach my $i (2,3) {
	$pA->[$i] .= ' ' x ($maxLen[$i]-length($pA->[$i]));
    }
    foreach my $i (0 .. $#$pA) {
	my $len = $maxLen[$i];
	print " " if ($i > 0);
	printf("%${len}s",$pA->[$i]);
    }
    print "\n";
}
