#!/usr/bin/env perl

# For Vasso and Jason. Run in para/match directory.
# See the user manual for the format of the alignmentClashRates.txt files.

use FileHandle;
use File::Basename;
use strict;

foreach my $f (glob("*/alignmentClashRates.txt")) {
    my $chr = dirname($f);
    my $fh = new FileHandle($f);
    my @count;
    while (<$fh>) {
	chomp;
	my @a = split;
	next if ($a[6]); # "extra" alignment
	my ($nDis,$from,$to) = @a[3,8,9];
	my $len = $to-$from+1;
	my $w = $nDis/$len; # density
	# Window 1 is offsets 1 to 1000
	my $iLo = int(($from-1)/1000)+1;
	my $iHi = int(($to-1)/1000)+1;
	foreach my $i ($iLo .. $iHi) {
	    my $bot = max(($i-1)*1000+1,$from);
	    my $top = min($i*1000,$to);
	    my $sz = $top-$bot+1;
	    $count[$i] += $sz*$w;
	}
    }
    foreach my $i (0 .. $#count) {
	if ($count[$i]) {
	    printf("%s %4d %7.2f\n",$chr,$i,$count[$i]);
	}
    }
}

sub max {
    my ($a,$b) = @_;
    if ($a > $b) {
	return $a;
    } else {
	return $b;
    }
}

sub min {
    my ($a,$b) = @_;
    if ($a < $b) {
	return $a;
    } else {
	return $b;
    }
}

