#!/usr/bin/env perl

# Run in assembly dir with */genome.ali.gz files

use Utility;
use File::Basename;
use strict;

foreach my $f (glob("*/genome.ali.gz")) {
    alignmentToAssembly($f,dirname($f) . "/assembly.fa");
}

sub alignmentToAssembly {
    my ($f,$g) = @_;
    if (stamp($g)) {
	report("$g: creating");
	my $fh = openToRead($f);
	my $gh = openToWrite($g);
	my $buf;
	while (<$fh>) {
	    if (/^>/) {
		if ($buf) {
		    print $gh "$buf\n";
		    $buf = "";
		}
		print $gh $_;
	    } else {
		my $v = substr($_,2,1);
		$v =~ tr/a-z/A-Z/;
		if ($v =~ /[A-Z]/) {
		    $buf .= $v;
		    if (length($buf) == 60) {
			print $gh "$buf\n";
			$buf = "";
		    }
		}
	    }
	}
	if ($buf) {
	    print $gh "$buf\n";
	}
	unstamp($g);
	report();
    }
}
