#!/usr/bin/perl

# Input: chr name, matches.gz and qualities.gz files
# Output: match strings

use Utility;
use SGRP::CreateReadLayout;
use SGRP::Alignment;
use strict;

if (@ARGV == 4) {
    alignmentsToMatchStrings(@ARGV);
} else {
    die("Usage: $0 chr aliFile qualFile outFile\n");
}

sub alignmentsToMatchStrings {
    my ($chr,$aliFile,$qualFile,$outFile) = @_;
    my $ah = openToRead($aliFile);
    chomp (my $aSaved = <$ah>); # initialize
    my $qh = openToRead($qualFile);
    my $gh = openToPipe("sort | gzip -c > $outFile");
    my $pAli;
    #my %isInsertionPosition;
    while (1) {
	#print "$aSaved\n";
	$pAli = readAlignment($ah,\$aSaved,$qh,$chr); # from crlo
	last unless ($pAli);
	foreach my $ms ($pAli->getMatchStrings()) {
	    #my ($start,$op) = split(" ",$ms,3);
	    #$isInsertionPosition{$start} = 1 if ($op eq 'I');
	    print $gh "$ms\n";
	}
    }
    $gh->close();
}


#    my $fh = openToRead("tmp.gz");
#    my $gh = openToPipe("sort | gzip -c > $outFile");
#    my @ipList = sort {$a <=> $b} keys %isInsertionPosition;
#    while (<$fh>) {
#	chomp;
#	my ($start,$op,$len,$str,$nucs,$quals) = split;
#	while (@ipList && $ipList[0] <= $start) {
#	    shift @ipList;
#	}
#	unless ($op eq 'I') {
#	    my $k=0; # offset in ipList
#	    while ($k <= $#ipList && $ipList[$k] < $start+$len) {
#		my $d = $ipList[$k]-$start;
#		printf($gh "%8d %s %5d %s",
#		       $start,$op,$d,$str);
#		if ($nucs) {
#		    printf($gh " %s %s\n",substr($nucs,0,$d),substr($quals,0,$d));
#		    $nucs = substr($nucs,$d);
#		    $quals = substr($quals,$d);
#		    $start += $d;
#		    $len -= $d;
#		} else {
#		    print $gh "\n";
#		}
#		$k ++;
#	    }
#	}
#	# Print remainder
#	printf($gh "%8d %s %5d %s %s",$start,$op,$len,$str);
#	if ($nucs) {
#	    printf($gh "%s %s\n",$nucs,$quals);
#	} else {
#	    print $gh "\n";
#	}
#    }
#}
