#!/usr/bin/env perl

# Given CONSENSUS alignment file(s), output "rev_" reverse-strand versions.

use Utility;
use File::Basename;
use strict;

foreach my $f (reverse @ARGV) {
    mayAlitac($f);
}

sub mayAlitac {
    my ($f) = @_;
    my $d = dirname($f);
    my $b = basename($f);
    my $g = "$d/rev_$b";
    alitac($f,$g) unless (-s $g);
}

sub alitac {
    my ($f,$g) = @_;
    my $gh = openToWrite($g);
    my $fh = openToRead($f);
    my $hdr = <$fh>;
    print $gh $hdr;
    $fh->close();
    $fh = openFromPipe(($f =~ /\.gz$/) ? "gunzip -c $f | tac" : "tac $f");
    while (<$fh>) {
	unless ($_ eq $hdr) {
	    my $iLim = length($_);
	    for (my $i=0; $i<$iLim; $i+=2) {
		my $v = substr($_,$i,1);
		$v =~ tr/ACGTacgt/TGCAtgca/;
		substr($_,$i,1) = $v;
	    }
		print $gh $_;
	}
    }
}

    
