#!/usr/bin/env perl

# Run from e.g. $SGR/read/SK1/cere

use Utility;
use strict;

my $fh = openToRead("../renamed.wm");
my %range;
my %len; # of good part
while (<$fh>) {
    chomp;
    my ($read,undef,$lo,$hi,@rest) = split;
    unless (@rest) {
	$range{$read} = [$lo,$hi];
	$len{$read} = $hi-$lo+1;
    }
}

my $fh = openToRead("alilines.all.txt");
while (<$fh>) {
    chomp;
    my (undef,undef,$read,undef,$alo,$ahi) = split;
    my $pR = $range{$read};
    if (defined $pR) {
	($alo,$ahi) = sort {$a <=> $b} ($alo,$ahi);
	my ($lo,$hi) = @$pR;
	unless ($alo > $hi || $lo > $ahi) {
	    my $left = $alo-$lo;
	    my $right = $hi-$ahi;
	    if ($left > $right) {
		$hi = ($left > 0) ? $alo-1 : undef;
	    } else {
		$lo = ($right > 0) ? $ahi+1 : undef;
	    } 
	}
	if (defined $lo && defined $hi && $lo > 0 && $hi > 0) {
	    $range{$read} = [$lo,$hi];
	} else {
	    delete $range{$read};
	}
    }
}
foreach my $r (sort keys %range) {
    my ($lo,$hi) = @{$range{$r}};
    my $len = $hi-$lo+1;
    if ($len > 1) {
	my $l = $len{$r};
	printf("%4d %15s %3d %3d %4d %d\n",$len,$r,$lo,$hi,$l,$l == $hi-$lo+1);
    }
}

    
