#!/usr/bin/env perl

# Input: lines of form "cat1 cat2 n"

use strict;

my (%c,%sum1,%sum2,$sum);
while (<>) {
    chomp;
    my ($cat1,$cat2,$n) = split;
    $c{$cat1}{$cat2} = $n;
    $sum1{$cat1} += $n;
    $sum2{$cat2} += $n;
    $sum += $n;
}

while (1) {
    my ($topZ,$top1,$top2,$topMu,$topN);
    foreach my $cat1 (sort keys %c) {
	my $pH = $c{$cat1};
	foreach my $cat2 (sort keys %sum2) {
	    my $n = $pH->{$cat2};
	    if ($n >= 0) {
		my $mu = $sum1{$cat1}*$sum2{$cat2}/$sum;
		my $z;
		if ($n > $mu) {
		    my $sd = sqrt($mu*(1-$mu/$sum));
		    $z = ($n-$mu)/$sd;
		} else {
		    $n = 0.5 if ($n < 0.5);
		    my $sd = sqrt($n*(1-$n/$sum));
		    $z = ($mu-$n)/$sd;
		}
		if ($z > $topZ) {
		    ($topZ,$top1,$top2,$topMu,$topN) = ($z,$cat1,$cat2,$mu,$n);
		}
	    }
	}
    }
    last if ($topZ < 2);
    $topZ = -$topZ if ($topMu > $topN);
    printf("%8.3f %25s %25s %6d %6d\n",
	   $topZ,$top1,$top2,$topMu,$topN);
    # Remove the cell
    $c{$top1}{$top2} = -1;
    my $d = $topMu-$topN;
    $sum1{$top1} += $d;
    $sum2{$top2} += $d;
    $sum += $d;
}
