#!/usr/bin/env perl

# Args: mgr_in args_bl idx1 idx2

use Utility;
use strict;

if (@ARGV == 4) {
    argsDistances(@ARGV);
} else {
    die("Usage: $0 mgr_in args_bl idx1 idx2");
}

sub argsDistances {
    my ($mf,$af,$idx1,$idx2) = @_;

    my $mh = openToRead($mf);
    my $hdr = <$mh>;
    chomp $hdr;
    my (undef,$mc) = split(" ",$hdr);
    my @mark;
    foreach my $i (0 .. $mc-1) {
	chomp ($mark[$i] = <$mh>);
    }
    
    my $fh = openToRead($af);
    my (@num,@den);
    while (<$fh>) {
	chomp;
	my ($lo,undef,$hi,$tot,@pairs) = split;
	my $d = distanceInTree($idx1,$idx2,\@pairs);
	for (my $i=$lo; $i<=$hi; $i++) {
	    $num[$i] += $d*$tot;
	    $den[$i] ++;
	}
    }
    foreach my $i (0 .. $#mark-1) {
	my $d = $num[$i]/$den[$i];
	printf("%d %10.6f\n",$mark[$i],$d);
	printf("%d %10.6f\n",$mark[$i+1]-1,$d);
    }
}

sub distanceInTree {
    my ($idx1,$idx2,$pPairs) = @_;
    my @ancs1 = ancestors($idx1,$pPairs);
    my @ancs2 = ancestors($idx2,$pPairs);
    my %isAnc2 = map {$_ => 1} @ancs2;
    foreach my $j (@ancs1) {
	if ($isAnc2{$j}) {
	    return distanceFromTo($idx1,$j,$pPairs)+distanceFromTo($idx2,$j,$pPairs);
	}
    }
}

sub ancestors {
    my ($idx,$pPairs) = @_;
    my $k = $idx*2+1;
    if ($k <= $#$pPairs) {
	return ($idx,ancestors($pPairs->[$k],$pPairs));
    } else {
	return ($idx);
    }
}

sub distanceFromTo {
    my ($i,$j,$pPairs) = @_;
    if ($i == $j) {
	return 0;
    } else {
	return $pPairs->[2*$i]+distanceFromTo($pPairs->[2*$i+1],$j,$pPairs);
    }
}

