#!/usr/bin/env perl

# Input: alilines
# Output: subset of input, pruning out lines overlapped (in the genome)
# by higher-scoring ones.

use Utility;
use strict;

my %ali;
while (<>) {
    chomp;
    my (undef,$score,undef,$chr,undef,undef,$lo,$hi) = split;
    ($lo,$hi) = sort {$a <=> $b} ($lo,$hi);
    unless (defined $ali{$chr}{$lo} && $ali{$chr}{$lo}[0] >= $score) {
	$ali{$chr}{$lo} = [$score,$hi,$_,1]; # 1 means still OK
    }
}

foreach my $chr (sort keys %ali) {
    my $pH = $ali{$chr};
    my @offs = sort {$a <=> $b} keys %$pH;
    for (my $i=0; $i<$#offs; $i++) {
	my $pITrip = $pH->{$offs[$i]};
	my $max = $pITrip->[1];
	for (my $j=$i+1; $j<=$#offs && $offs[$j] <= $max; $j++) {
	    if ($pITrip->[1] >= $offs[$j]) {
		my $pJTrip = $pH->{$offs[$j]};
		if ($pJTrip->[3]) {
		    if ($pITrip->[0] >= $pJTrip->[0]) {
			$pJTrip->[3] = 0; # prune out
		    } else {
			$pITrip->[3] = 0;
		    }
		}
	    }
	}
    }
    foreach my $off (@offs) {
	my $pTrip = $pH->{$off};
	if ($pTrip->[3]) {
	    print $pTrip->[2] . "\n";
	}
    }
}
