#!/usr/bin/env perl

use Utility;
use strict;

foreach my $d (@ARGV) {
    my $sh = openToRead("$d/sequenced.gz");
    chomp (my $hdr = <$sh>);
    my @strains = split(" ",$hdr);
    my %strIdx;
    foreach my $i (0 .. $#strains) {
	$strIdx{$strains[$i]} = $i;
    }
    my $lh = openToRead("$d/layout.gz");
    my @strainAt;
    my $off = 0;
    my $gsh = openToWrite("$d/sequenced.binmap.txt");
    my $glh = openToWrite("$d/layout.binmap.txt");
    while (<$lh>) {
	chomp;
	if (/^>/) {
	    my ($spec,$pos,$iter) = split(" ",substr($_,1));
	    if (defined $iter) {
		my ($str) = split(/-/,$spec);
		$strainAt[2*($pos+1)] = $strIdx{$str};
	    }
	} else {
	    $off ++;
	    my $iLim = length($_);
	    my @lPres;
	    my @sPres;
	    foreach my $i (0 .. $#strains) {
		$lPres[$i] = 0;
		$sPres[$i] = 0;
	    }
	    for (my $i=2; $i<$iLim; $i+=2) {
		my $v = substr($_,$i,1);
		if ($v =~ /[ACGTacgt]/) {
		    $lPres[$strainAt[$i]] = 1;
		}
	    }
	    chomp (my $sLine = <$sh>);
	    my $iLim = length($sLine);
	    for (my $i=2; $i<$iLim; $i+=2) {
		my $v = substr($sLine,$i,1);
		if ($v =~ /[ACGTacgt]/) {
		    $sPres[$i/2-1] = 1;
		}
	    }
	    my $s01 = join("",@sPres);
	    my $l01 = join("",@lPres);
	    print $gsh $s01 . "\n";
	    print $glh $l01 . "\n";
	}
    }
}
