#!/usr/bin/env perl

use Utility;
use Getopt::Std;
use strict;

my %OPT;
getopts('h',\%OPT);

my @ids = @ARGV;
my %want;
foreach my $id (@ids) {
    if ($id =~ /^(\d+)-(\d+)$/ && $1 <= $2) {
	my ($lo,$hi) = ($1,$2);
	foreach my $i ($lo .. $hi) {
	    $want{$i} = 1;
	}
    } else {
	$want{$id} = 1;
    }
}

if ($OPT{h}) {
    print " JobID          Job Name        Submitted  Started   CPU IDFA  MEM SWAP\n";
}
my $fh = openFromPipe("bjobs -l");
my ($num,$name,$subm,$start,$cpu,$idle,$mem,$swap);
while (<$fh>) {
    chomp;
    if (/^Job <(\d+)>, Job Name <(\S+)>,/) {
	discharge();
	$num = $1;
	$name = $2;
    } elsif (/ ([0-9:]*): Submitted/) {
	$subm = $1;
    } elsif (/ ([0-9:]*): Started/) {
	$start = $1;
    } elsif (/IDLE_FACTOR.*\s(\S+)$/) {
	$idle = $1;
    } elsif (/MEM: (\d+) Mbytes;  SWAP: (\d+) Mbytes; /) {
	$mem = $1;
	$swap = $2;
    } elsif (/The CPU time used is (\d+) seconds/) {
	$cpu = $1;
    }
}
discharge();

sub discharge {
    return unless (defined $num && defined $start);
    return if (%want && !$want{$num});
    printf("%6d %25s %8s %8s %5d %4.2f %4d %4d\n",
	   $num,$name,$subm,$start,$cpu,$idle,$mem,$swap);
    ($num,$name,$subm,$start,$cpu,$idle,$mem,$swap) = ();
}

     
