#!/usr/bin/env perl

use Utility;
use strict;

my $fh = openFromPipe("bjobs -u all");
<$fh>; # header
my %c;
while (<$fh>) {
    my (undef,$uid,$state) = split;
    $state = 'OTHER' if ($state ne 'RUN' && $state ne 'PEND');
    $c{$uid}{$state} ++;
}

my $idx = 0;
foreach my $uid (sort {$c{$b}{RUN} <=> $c{$a}{RUN} || $c{$b}{PEND} <=> $c{$a}{PEND}} keys %c) {
    my $yh = openFromPipe("ypmatch $uid passwd 2>/dev/null");
    $_ = <$yh>;
    my @a = split(/:/,$_);
    my $who = $a[4];
    $who =~ s/[\(,].*//;
    $idx ++;
    printf("%3d %7s %25s",$idx,$uid,$who);
    my $pH = $c{$uid};
    foreach my $state (qw(RUN PEND OTHER)) {
	my $n = $pH->{$state};
	if ($n > 0) {
	    printf(" %5s %4d",$state,$pH->{$state});
	} else {
	    printf("%11s","");
	}
    }
    print "\n";
}

   
