#!/usr/bin/env perl

use Utility;
use strict;

my $centre = $ARGV[0];

chdir("$ENV{G1K}/v1");
my @count;
foreach my $f (glob("*/NA?????/lib${centre}*/lane*/qualmapLH.txt")) {
    my $fh = openToRead($f);
    my (@max,@min,@qual,@num);
    while (<$fh>) {
	chomp;
	my ($r,$p,undef,undef,$n,$m) = split;
	$max[$r] = max($max[$r],$p);
	$min[$r] = min($min[$r],$p);
	if ($n>=100 && $m>=1 && $m<=$n) {
	    my $ep = $m/$n;
	    my $q = int(0.5-10*log($ep)/log(10));
	    $qual[$r][$p] = $q;
	    $num[$r][$p] = $n;
	}
    }
    foreach my $r (0 .. $#qual) {
	if ($qual[$r]) {
	    foreach my $p ($min[$r]+1 .. $max[$r]-1) {
		my $q = $qual[$r][$p];
		if (defined $q) {
		    $count[$q] += $num[$r][$p];
		}
	    }
	}
    }
}
my $sum;
foreach my $v (@count) {
    $sum += $v;
}
foreach my $q (0 .. $#count) {
    printf("%2d %12.10f\n",$q,$count[$q]/$sum);
}
