#!/usr/bin/env perl

use Utility;
use strict;
my %cds;
my $total;
while (<>) {
    chomp;
    my @a = split;
    if ($a[2] eq 'CDS') {
	push @{$cds{$a[0]}},[$a[3],$a[4]];
    } elsif ($a[2] eq 'chromosome') {
	$total += $a[4];
    }
}

my $sum;
foreach my $pA (values %cds) {
    my @sorted = sort {$a->[0] <=> $b->[0]} @$pA;
    my @merged;
    foreach my $pPair (@sorted) {
	my ($lo,$hi) = @$pPair;
	if (@merged && $merged[-1][1] >= $lo-1) {
	    $merged[-1][1] = max($merged[-1][1],$hi);
	} else {
	    push @merged,$pPair;
	}
    }
    foreach my $pPair (@merged) {
	$sum += $pPair->[1]-$pPair->[0]+1;
    }
}
my $frac = $sum/$total;
print "CODING $sum out of $total = fraction $frac\n";
