#!/usr/bin/env perl

# Run from e.g. ~/sgrp/g1k/DATA

use FileHandle;
use strict;

my $gh = new FileHandle("| sort +1 -nr");
foreach my $f (glob("*/*/*/*/*.fastq")) {
    my $fq = readlink($f);
    next unless (-s $fq);
    (my $srf = $fq) =~ s/fastq$/srf/;
    next unless (-s $srf);
    my $sz1 = -s $fq;
    my $sz2 = -s $srf;
    my $r = $sz1/$sz2;
    if ($r < 0.07 || $r > 0.14) {
	printf($gh "%8.6f %35s %35s\n",$r,$f,$fq);
    }
}
