#!/usr/bin/env perl

use Utility;
use strict;

foreach my $f (@ARGV) {
    checkHardGapAgreement($f);
}

sub checkHardGapAgreement {
    my ($f) = @_;
    my $fh = openToRead($f);
    my $ln=0;
    my @anno;
    my @strain;
    my $errs = 0;
    while (<$fh>) {
	chomp;
	$ln ++;
	if (/^>REF/) {
	    # nothing
	} elsif (/^>(\S+)-\S+ (\d+) /) {
	    my ($str,$col) = ($1,$2);
	    $anno[$col] = sprintf("%7d %s",$ln,$_);
	    $strain[$col] = $str;
	} else {
	    my $orig = $_;
	    s/^..//;
	    s/(.)./\1/g;
	    my $len = length($_);
	    next unless (/=/ && /[^=]/);
	    for (my $c1=0; $c1 < $len-1; $c1++) {
		my $v1 = substr($_,$c1,1);
		next if ($v1 eq ' ');
		my $s1 = $strain[$c1];
		for (my $c2 = $c1+1; $c2 < $len; $c2 ++) {
		    my $v2 = substr($_,$c2,1);
		    if ($v2 ne ' ' && $strain[$c2] eq $s1 && ($v1 eq '=') ne ($v2 eq '=')) {
			#print "Clash at line $ln for $s1, pos $c1 and $c2, $anno[$c1] and $anno[$c2]\n$orig\n";
			printf("Clash:\n%s\n%s\n%7d %s\n",$anno[$c1],$anno[$c2],$ln,$orig);
			$errs ++;
		    }
		}
	    }
	}
    }
    print "$f: $errs errors\n";
}
