#!/usr/bin/env perl

use Utility;
use strict;

autoflush STDOUT 1;

my @PATS=('Hostname:',
	  'processing sequence',
	  'OF COMMAND STDERR',
	  'finish writing file',
	  'sequences were loaded',
	  'Return value: [02]',
	  'Command:',
	  'loading reads',
	  'set length of the',
	  'round ./',
	  'making index',
	  'have been sorted out',
	  'are added afterwards',
	  'encoding reads',
	  'set the minimum insert size as',
	  'reads are moved',
	  'reads loaded',
	  'candidates for alignment',
	  'align_candidate.*out of',
	  'sorting the hits',
	  '^\[mapping_count_single\] [\d, ]*$',
	  '^-- maq-',
	  'quality counts of the',
	  'read pairs counted',
	  'poorly mapped reads',
	  'CPU time:',
	  'raw reads are mapped',
	  'total, isPE, mapped, paired');

chdir("$ENV{G1K}/v1");
foreach my $d (glob("Trio-CEU/NA?????/lib*/lane*")) {
    if (! -s "$d/recalibrated.fastq.gz") {
	print "$d: no recalibrated.fastq.gz\n";
    } else {
	my $sz = -s "$d/aln.map";
	if (defined $sz) {
	    print "$d: size $sz for aln.map, ";
	} else {
	    print "$d: missing aln.map, ";
	}
	#print "$d\n";
	my @files = glob("$d/lane*/*.err");
	printf("%d .err files\n",scalar(@files));
	foreach my $f (@files) {
	    checkMaqErrorFile($f);
	}
    }
}

sub checkMaqErrorFile {
    my ($f) = @_;
    my $fh = openToRead($f);
  LOOP:
    while (<$fh>) {
	chomp;
	foreach my $p (@PATS) {
	    next LOOP if (/$p/);
	}
	print "$f:$_\n";
    }
}

