#!/usr/bin/env perl

use Utility;
use strict;

foreach my $d (@ARGV) {
    checkMatchesInLayout($d);
}

sub checkMatchesInLayout {
    my ($d) = @_;
    my $mf = "$d/matches.gz";
    my $lf = "$d/layout.gz";
    my $fh = openToRead($mf);
    my %matched;
    my $ln = 0;
    while (<$fh>) {
	$ln++;
	if (/^ALIGNMENT/) {
	    my (undef,undef,$r,undef,$x,$y,undef,undef,$fc,undef,undef,$cuts) = split;
	    if ($cuts =~ /\|(\d+),(\d+)$/) {
		my ($c1,$c2) = ($1,$2);
		if ($fc eq 'F') {
		    $x += $c1;
		    $y -= $c2;
		} else {
		    $x -= $c2;
		    $y += $c1;
		}
	    }
	    $matched{"$r:$x:$y"} = "$ln:$_";
	}
    }
    $fh = openToRead($lf);
    while (<$fh>) {
	if (/^>(\S+)/) {
	    delete $matched{$1};
	}
    }
    foreach my $key (sort keys %matched) {
	print "MISSING $d $key $matched{$key}\n";
    }
}
