#!/usr/bin/perl

use Utility;
use File::Basename;
use strict;

foreach my $f (glob("$ENV{G1K}/DATA/*/*/libBI*/*/*fastq.gz")) {
    my $d = dirname($f);
    (my $rlFile = $f) =~ s/fastq.gz$/readlengths/;
    my $fh = openToRead($rlFile);
    chomp ($_ = <$fh>);
    my ($len1,$len2) = split;
    if ($len2 > 0) {
	my $tgt = readlink($f);
	my $td = dirname($tgt);
	my $tb = basename($tgt,".fastq.gz");
	my $fqLen = getReadLength($tgt);
	my $fqLen1 = getReadLength("$td/bi_separate/${tb}_1.fastq.gz");
	my $fqLen2 = getReadLength("$td/bi_separate/${tb}_2.fastq.gz");
	unless ($len1 == $fqLen1 && $len2 == $fqLen2) {
	    printf("%2d %2d %2d %2d %2d %s\n",$len1,$len2,$fqLen,$fqLen1,$fqLen2,$tgt);
	}
    }
}

sub getReadLength {
    my ($f) = @_;
    if (-s $f) {
	my $fh = openToRead($f);
	<$fh>;
	chomp ($_  = <$fh>);
	return length($_);
    } else {
	return -1;
    }
}
