#!/usr/bin/env perl

use Utility;
use strict;

foreach my $d (@ARGV) {
    checkReadFates($d);
}

sub checkReadFates {
    my ($d) = @_;
    my %pass;
    foreach my $f (glob("$d/align/*/alilines.pass.txt")) {
	my $fh = openToRead($f);
	while (<$fh>) {
	    chomp;
	    my (undef,undef,$r) = split;
	    $pass{$r} = 1;
	}
    }
    my %acc;
    foreach my $f (glob("$d/p?/*/alilines.nola.txt")) {
	my $fh = openToRead($f);
	while (<$fh>) {
	    chomp;
	    my (undef,undef,$r) = split;
	    $acc{$r} = 1;
	}
    }
    my %rej;
    foreach my $f (glob("$d/p?/*/alilines.nola.log")) {
	my $fh = openToRead($f);
	while (<$fh>) {
	    chomp;
	    my (undef,$c) = split;
	    $rej{$c} = 1;
	}
    }
    foreach my $r (sort keys %pass) {
	next if (defined $acc{$r} || defined $rej{$r});
	my $c = $r;
	$c =~ s/\.[pq]1k$//;
	unless (defined $rej{$c}) {
	    print "Fate missing in $d: $r\n";
	}
    }
}

