#!/usr/bin/env perl

use Utility;
use strict;

my @BASES = qw(sample/30m.fastq
               sample/aln.map
               qualmapBayesian.txt
               recalibrated.fastq.gz
               aln.map);

chdir("$ENV{G1K}/v1");
foreach my $d (glob("*/NA?????/lib*/lane*")) {
    foreach my $b (@BASES) {
	my $f = "$d/$b";
	if (! -f $f) {
	    printf("%8d ",-1);
	} else {
	    my $sz = -s $f;
	    if ($b =~ /\.txt$/) {
		printf("%8d ",$sz);
	    } else {
		printf("%8.3f ",$sz/1000000);
	    }
	}
    }
    print "$d\n";
}
