#!/usr/bin/perl

# Run in e.g. $SGR/ref/cere

use strict;

unless (@ARGV) {
    die("Usage: $0 chunkSize file1 file2 ...");
}

# Should be multiple of 50 ...
my $CHUNK_SIZE = shift @ARGV;

my ($chr,$buf);
while (<>) {
    chomp;
    if (/^>/) {
	chopAndPrint($chr,$buf) if ($buf);
	$buf = "";
	$chr = substr($_,1);
    } else {
	$buf .= $_;
    }
}
chopAndPrint($chr,$buf) if ($buf);

sub chopAndPrint {
    my ($chr,$buf) = @_;
    my $len = length($buf);
    my $iMax;
    for (my $i=0; $i<$len; $i+=$CHUNK_SIZE) {
	printChunk($chr,$buf,$i-2000,4000) if ($i > 0);
	my $sz = $CHUNK_SIZE;
	$sz = $len-$i if ($sz > $len-$i);
	printChunk($chr,$buf,$i,$sz);
	$iMax = $i;
    }
}

sub printChunk {
    my ($chr,$buf,$i,$len) = @_;
    my $loc = sprintf("%s.%7d",$chr,$i); # $i is offset from start
    $loc =~ tr/ /0/;
    print ">$loc\n";
    for (my $j=$i; $j<$i+$len; $j+=50) {
	print substr($buf,$j,50) . "\n";
    }
}
