#!/usr/bin/env perl

# Run this on final iter dir ...

use Utility;
use strict;

foreach my $b (qw(sorted_z imputed_z)) {
    foreach my $f (glob("p?/*/$b.gz")) {
	my $g = $f;
	$g =~ s/\.gz$/_new.gz/;
	my $e = $f;
	$e =~ s/\.gz$/_old.gz/;
	next if (-s $e);
	next unless (stamp($g));
	report("$g: creating");
	my $fh = openToRead($f);
	my $gh = openToWrite($g);
	# Header
	my $hdr = <$fh>;
	print $gh $hdr;
	my $n = 0;
	while (<$fh>) {
	    unless (substr($_,1,1) eq ' ') {
		substr($_,1,1) = ' ';
		$n++;
	    }
	    print $gh $_;
	}
	print "$n changes ... ";
	$gh->close();
	if ($n > 0) {
	    rename($f,$e);
	    rename($g,$f);
	} else {
	    unlink($g);
	}
	unstamp($g);
	report();
    }
}
