#!/usr/bin/env perl

use Utility;
use strict;

my $xMax = 500;
my $yMax = 200;

print <<\EOF;
%!PS-Adobe-2.0 EPSF-2.0
EOF

print "%%BoundingBox: 0 $xMax 0 $yMax\n";
print "%%HiResBoundingBox: 0.000000 $xMax.000000 0.000000 $yMax.000000\n";

print <<\EOF;
%%EndComments
%%BeginProlog
save
countdictstack
mark
newpath
/showpage {} def
/setpagedevice {pop} def
%%EndProlog
%%Page 1 1
1 setlinecap 1 setlinejoin 1 setlinewidth 0 setgray
/basefont /Times-Roman findfont 12 scalefont def
/titlefont /Times-Roman findfont 12 scalefont def
50 600 translate
titlefont setfont
basefont setfont
EOF

copyLines("ceru_nonames.eps",0,$xMax*.45,0,$yMax);
copyLines("pars_nonames.eps",$xMax*.55,$xMax,0,$yMax);

print <<\EOF;
showpage
%%Trailer
cleartomark
countdictstack
exch sub { end } repeat
restore
%%EOF
EOF

sub copyLines {
    my ($f,$xl,$xr,$yb,$yt) = @_;
    my $fh = openToRead($f);
    chomp (my @lines = <$fh>);
    my ($xlo,$xhi,$ylo,$yhi);
    foreach my $line (@lines) {
	if ($line =~ /(move|line)to/) {
	    my @a = split(" ",$line);
	    foreach my $i (2 .. $#a) {
		if ($a[$i] eq 'moveto' || $a[$i] eq 'lineto') {
		    $xlo = min($xlo,$a[$i-2]);
		    $xhi = max($xhi,$a[$i-2]);
		    $ylo = min($ylo,$a[$i-1]);
		    $yhi = max($yhi,$a[$i-1]);
		}
	    }
	}
    }
    foreach my $line (@lines) {
	if ($line =~ /(move|line)to/) {
	    my @a = split(" ",$line);
	    foreach my $i (2 .. $#a) {
		if ($a[$i] eq 'moveto' || $a[$i] eq 'lineto') {
		    $a[$i-2] = int(0.5+$xl+($xr-$xl)*($a[$i-2]-$xlo)/($xhi-$xlo));
		    $a[$i-1] = int(0.5+$yb+($yt-$yb)*($a[$i-1]-$ylo)/($yhi-$ylo));
		    if ($a[$i] eq 'moveto' && $a[$i+2] eq 'show') {
			my $len = length($a[$i+1])-2;
			$a[$i-2] -= ($len+1);
			$a[$i-1] += 5;
		    }
		}
	    }
	    print join(" ",@a) . "\n";
	}
    }
}


	
