#!/usr/bin/env perl

# Run on e.g. csd.MAX files. Output can be handed to R (read.table with header=T)
# and then:
#
# plot(Qu,NSQ)
# 

use strict;

my @sum;
my $iMax;
while (<>) {
    chomp;
    if (/^[ 1][ 0-9][0-9] /) {
	my ($q,@a) = split;
	foreach my $i (0 .. $#a) {
	    $sum[$q][$i] += $a[$i];
	    # Types 0,1,3,4 are i=0,1, 3,4, 9,10, 12,13
	}
	$sum[$q][$#a+1] += $a[0]+$a[3]+$a[9]+$a[12];
	$sum[$q][$#a+2] += $a[1]+$a[4]+$a[10]+$a[13];
	$iMax = $#{$sum[$q]} if ($iMax < $#{$sum[$q]});
    }
}

print " Qu ";
for (my $i=0; $i<$iMax; $i+=3) {
    my $j = $i/3;
    printf("%7s%d %5s%d %7s%d %5s%d ",
	   'Tot',$j,'Dis',$j,'Rat',$j,'Qu',$j);
}
print "\n";

foreach my $q (0 .. $#sum) {
    printf("%3d",$q);
    for (my $i=0; $i<$iMax; $i+=3) {
	my $n = $sum[$q][$i];
	my $b = $sum[$q][$i+1];
	if ($n >= 1000 && $b > 0) {
	    my $r = ($n+0.002)/($b+0.001);
	    my $q=int(0.5+10*log($r)/log(10));
	    printf(" %8d %6d %8.2f %6.1f",$n,$b,$r,$q);
	} else {
	    printf(" %8d %6d %8s %6s",$n,$b,'NA','NA');
	}
    }
    print "\n";
}
