#!/usr/bin/perl

use Utility;
use strict;

my $PFX = 'TESTB20_exp1_pc25';

my @keys = qw(Truth Input Marks David);

my @in;
# Truth
$in[0] = openToRead("${PFX}_truth.margarita");
# Input
$in[1] = openToRead("${PFX}.margarita");
# His
$in[2] = openToRead("${PFX}.margarita.margaritaimputation");
# Mine
$in[3] = openToRead("${PFX}.margarita.timesimputation");

my ($ns,$nm);
foreach my $fh (@in) {
    $_ = <$fh>;
    chomp;
    ($ns,$nm) = split;
}
foreach my $n (1 .. $nm) {
    foreach my $fh (@in) {
	<$fh>;
    }
}

# Now the data we want.
my @vals;
foreach my $i (0 .. $ns-1) {
    foreach my $k (0 .. $#in) {
	my $fh = $in[$k];
	chomp ($_ = <$fh>);
	my (undef,$seq) = split;
	foreach my $m (0 .. $nm-1) {
	    $vals[$m][$k][$i] = substr($seq,$m,1);
	}
    }
}

foreach my $m (0 .. $#vals) {
    my $buf;
    print "\nMarker $m\n";
    for (my $k=0; $k<=$#keys; $k++) {
	printf("%s %s\n",$keys[$k],join('',@{$vals[$m][$k]}));
    }
    print "Diffs ";
    foreach my $i (0 .. $ns-1) {
	my $truth = $vals[$m][0][$i];
	my $his = $vals[$m][2][$i];
	my $mine = $vals[$m][3][$i];
	my $quad = sprintf("%s%s%s%s",$truth,$vals[$m][1][$i],$his,$mine);
	if ($truth eq 'M' || ($his eq $mine && $his eq $truth)) {
	    print " ";
	} elsif ($his eq $truth) {
	    $buf .= "Mark better at haplotype $i, $quad\n";
	    print "-";
	} elsif ($mine eq $truth) {
	    $buf .= "David better at haplotype $i, $quad\n";
	    print "+";
	} else {
	    $buf .= "Neither better at haplotype $i, $quad\n";
	    print "!";
	}
    }
    print "\n$buf";
}

