#!/usr/bin/env perl

use Utility;
use strict;

# Args: sorted, imputed0, imputed1
# E.g.:
# cd /lustre/scratch1/sanger/dmc/sgroot/match/FREG200_1/freg/errs/000/p0/chr00
# compareImputed.pl /lustre/scratch1/sanger/dmc/sgroot/match/FREG_COMPLETE/200/p0/chr00/sorted.gz \
#    imputed_h.sv1.gz imputed_h.gz > ci_h.txt &

my $sh = openToRead($ARGV[0]);
my $hdr = <$sh>;
chomp $hdr;
my @strains = ('REF',split(" ",substr($hdr,1)));
my $fh0 = openToRead($ARGV[1]);
<$fh0>;
my $fh1 = openToRead($ARGV[2]);
<$fh1>;
my $ln = 0;
while (1) {
    my $line = <$sh>;
    my $line0 = <$fh0>;
    my $line1 = <$fh1>;
    last unless ($line && $line0 && $line1);
    $ln ++;
    chomp $line;
    chomp $line0;
    chomp $line1;
    my $max = min(length($line0),length($line1))-2;
    for (my $i=0; $i<=$max; $i+=2) {
	my $v0 = substr($line0,$i,1);
	my $v1 = substr($line1,$i,1);
	unless ($v0 eq $v1) {
	    printf("%7d %2s %2s %2s %s\n",$ln,substr($line,$i,2),substr($line0,$i,2),substr($line1,$i,2),$strains[$i/2]);
	}
    }
}
