#!/usr/bin/env perl

use Utility;
use strict;

my $READ="/lustre/scratch1/sanger/dmc/sgroot/read";

foreach my $s (@ARGV) {
    my $pS1 = readTopScores("$READ/$s/kell/alilines.all.txt");
    my $pS2 = readTopScores("$READ/$s/para/alilines.all.txt");
    foreach my $r (sort keys %$pS1) {
	my ($s1,$cont) = @{$pS1->{$r}};
	my $s2 = defined $pS2->{$r} ? $pS2->{$r}[0] : 0;
	printf("%s %4d %4d %s\n",$r,$s1,$s2,$cont);
    }
    foreach my $r (sort keys %$pS2) {
	unless (defined $pS1->{$r}) {
	    my $s2 = $pS2->{$r}[0];
	    printf("%s %4d %4d na\n",$r,0,$s2);
	}
    }
}

sub readTopScores {
    my ($f) = @_;
    my $fh = openToRead($f);
    my %top;
    while (<$fh>) {
	chomp;
	my ($tag,$score,$read,$chr) = split;
	unless ($chr =~ /\.[0-9][0-9][0-9]$/) {
	    unless (defined $top{$read} && $top{$read}[0] > $score) {
		$top{$read} = [$score,$chr];
	    }
	}
    }
    return \%top;
}
