#!/usr/bin/env perl

use Utility;
use strict;

foreach my $f (glob("$ENV{G1K}/v1/*-*/NA?????/lib*/lane*/sample/aln*mapcheck")) {
    my $fh = openToRead($f);
    chomp (my @lines = <$fh>);
    unless (@lines >= 9) {
	print STDERR "Truncated or empty: $f\n";
	next;
    }
    $lines[5] =~ s/[%,]//g;
    my @refComp = split(" ",$lines[5]);
    $lines[6] =~ s/[%,]//g;
    my @readComp = split(" ",$lines[6]);
    my @a = split(" ",$lines[8]);
    my $avd = $a[-1];
    my $h;
    my $r;
    foreach my $i (4,6,8,10) {
	my $e = $refComp[$i]/100;
	my $o = $readComp[$i]/100;
	if (($o == 0) != ($e == 0)) {
	    $r = 100;
	} else {
	    my $ratio = $o/$e;
	    $r = max($r,max($ratio,1/$ratio));
	}
	$h -= $o*log($e);
    }
    $h /= log(2);
    printf("%6.4f %6.4f %6.3f %s\n",$h,$r,$avd,$f);
}
