#!/usr/bin/env perl

use Utility;
use File::Basename;
use strict;

my $HOME = $ENV{HOME};

my $STAGE = -d "/staging" ? 1 : -d "$HOME/sgrp/g1k" ? 2 : die();

my %DIR;
if ($STAGE == 2) {
    foreach my $f (glob("$HOME/sgrp/g1k/DATA/*/*/*/*/*fastq")) {
	$DIR{basename($f,".fastq")} = dirname($f);
    }
}

my $fh = openToRead("$HOME/staging.txt");
while (<$fh>) {
    chomp;
    if (/\.srf$/) {
	my $from = $_;
	$from =~ s/\.srf$/_srf.md5/;
	if ($STAGE == 1) {
	    if (-s $from) {
		my $to = sprintf("%s/staging/%s.md5",$HOME,basename($_,".srf"));
		print "scp -p $from $to\n";
	    } else {
		print "echo MISSING $from\n";
	    }
	} else {
	    my $b = basename($_,".srf");
	    my $from = sprintf("%s/staging/%s.md5",$HOME,$b);
	    if ($DIR{$b}) {
		print "cp -p $from $DIR{$b}/$b.md5\n";
	    } else {
		print "echo No DIR for $b\n";
	    }
	}
    }
}

   
