#!/usr/bin/env perl

# Arg(s): sorted_ac.gz files

use Utility;
use strict;

autoflush STDOUT 1;

my @c;
my $ns;
foreach my $f (@ARGV) {
    report("$f: processing");
    my $fh = openToRead($f);
    my $hdr = <$fh>;
    my @a = split(" ",$hdr);
    $ns = scalar(@a)+1;
    while (<$fh>) {
	chomp;
	s/ //g;
	my $iMax = length($_)-1;
	my ($na,$nc);
	foreach my $i (0 .. $iMax) {
	    my $v = substr($_,$i,1);
	    if ($v eq 'A') {
		$na ++;
	    } elsif ($v eq 'C') {
		$nc ++;
	    } else {
		die("Bad character $v in $_");
	    }
	}
	$c[$na+$nc][$na] ++ if ($nc);
    }
    report();
}

my @wid;
foreach my $n (0 .. $ns) {
    my $pA = $c[$n];
    foreach my $na (0 .. $ns) {
	if ($pA->[$na]) {
	    $wid[$na] = max($wid[$na],length(max($na,$pA->[$na])));
	}
    }
}
printf("%3s %7s",'','TOTAL');
foreach my $na (0 .. $ns) {
    printf(" %$wid[$na]d",$na) if ($wid[$na]);
}
print "\n";
foreach my $n (0 .. $ns) {
    my $pA = $c[$n];
    my $tot = 0;
    foreach my $na (0 .. $ns) {
	$tot += $pA->[$na];
    }
    printf("%3d %7d",$n,$tot);
    foreach my $na (0 .. $ns) {
	printf(" %$wid[$na]d",$pA->[$na]) if ($wid[$na]);
    }
    print "\n";
}
