#!/usr/bin/env perl

# Opt: min qual score to count a hit.

# Args: imputed_y.gz files, or similar.

use Getopt::Std;

use Utility;
use strict;

my (%ins,%del,%OPT);

getopts('q:',\%OPT);

my $thc;
if (defined $OPT{q}) {
    $thc = chr(33+$OPT{q});
}

foreach my $f (@ARGV) {
    my $fh = openToRead($f);
    my $hdr = <$fh>;
    chomp $hdr;
    my @strains = split(" ",substr($hdr,1));
    while (<$fh>) {
	chomp;
	my $rv = substr($_,0,1);
	if ($rv =~ /[A-Z]/) {
	    my $k=0;
	    for (my $i=0; $i<=$#strains; $i++) {
		$k += 2;
		my $v = substr($_,$k,1);
		my $q = substr($_,$k+1,1);
		if ($v =~ /[-=_]/ && ($q eq ' ' || $q ge $thc)) {
		    $del{$strains[$i]} ++;
		}
	    }
	} else {
	    my $k=0;
	    for (my $i=0; $i<=$#strains; $i++) {
		$k += 2;
		my $v = substr($_,$k,1);
		my $q = substr($_,$k+1,1);
		if ($v =~ /[A-Za-z]/ && ($q eq ' ' || $q ge $thc)) {
		    $ins{$strains[$i]} ++;
		}
	    }
	}
    }
}

foreach my $s (sort keys %ins) {
    printf("%13s %6d %6d\n",$s,$ins{$s},$del{$s});
}
