#!/usr/bin/env perl

use Utility;
use strict;

foreach my $d (@ARGV) {
    coverageDistribution($d);
}

sub coverageDistribution {
    my ($d) = @_;
    foreach my $b (qw(layout sorted)) {
	my $f = "$d/$b.gz";
	my $g = "$d/${b}.covdist";
	if (-s $f && ! -s $g) {
	    report("creating $g");
	    coverageDistribution1($f,$g);
	    report();
	}
    }
}

sub coverageDistribution1 {
    my ($f,$g) = @_;
    my $fh = openToRead($f);
    my @count;
    while (<$fh>) {
	next unless (/^[ACGT]/);
	chomp;
	s/..//;
	s/(.)./\1/g;
	s/ //g;
	$count[length($_)] ++;
    }
    my $gh = openToWrite($g);
    my $sum;
    foreach my $v (@count) {
	$sum += $v;
    }
    my $cum=0;
    foreach my $k (0 .. $#count) {
	my $c = $count[$k];
	if ($c) {
	    $cum += $c/$sum;
	    printf($gh "%3d %7d %8.6f\n",$k,$c,$cum);
	}
    }
    $gh->close();
}
