#!/usr/bin/env perl

# Creates matrix suitable for snpDisc.R. Run in $SGR/match.
# Input files come from collectFregStatistics.pl.

use Utility;
use strict;

my %perc;

my $fh = openFromPipe("grep -h 'm  poly  poly' FREG*/freg/fregSNPStats.txt");

my %isC;
while (<$fh>) {
    my ($n,$c,$sol,$meth,$real,$app,$count) = split;
    if ($meth eq 'm' && !$sol && $real eq 'poly' && $app eq 'poly') {
	$perc{$n}{$c} = $count/95.33;
	$isC{$c} = 1;
    }
}

my @cList = sort {$a <=> $b} keys %isC;
foreach my $n (sort {$a <=> $b} keys %perc) {
    printf("%3d",$n);
    foreach my $c (@cList) {
	printf(" %6.2f",$perc{$n}{$c});
    }
    print "\n";
}

