#!/usr/bin/env perl

# Input: *.alpha matrix, with strain names as first field,
# then "+" or "-", then names of strains to keep or omit respectively

use FileHandle;
use strict;

my ($matFile,$op,@strains) = @ARGV;

unless (-s $matFile && ($op eq '+' || $op eq '-')) {
    die("Usage: $0 foo.alpha +|- str1 str2 ...\n");
}

my $fh = new FileHandle($matFile);
chomp (my $n = <$fh>);
$n = ($op eq '+') ? scalar(@strains) : $n-scalar(@strains);
print "$n\n";
my %named = map {$_ => 1} @strains;
my (@names,@mat);
my $i=0;
my @keep;
my %seen;
while (<$fh>) {
    chomp;
    my ($str,@dists) = split;
    $keep[$i] = ($named{$str} == ($op eq '+'));
    push @names,$str;
    push @mat,\@dists;
    $i ++;
    $seen{$str} = 1;
}
foreach my $str (@strains) {
    unless ($seen{$str}) {
	print STDERR "WARNING: did not find $str\n";
    }
}
foreach my $i (0 .. $#mat) {
    next unless ($keep[$i]);
    print $names[$i];
    my $pA= $mat[$i];
    foreach my $j (0 .. $#$pA) {
	print " $pA->[$j]" if ($keep[$j]);
    }
    print "\n";
}

       
