#!/usr/bin/env perl

use Utility;
use strict;

foreach my $f (@ARGV) {
    crossStrandData($f);
}

sub crossStrandData {
    my ($f) = @_;
    my $fh = openToRead($f);
    my (@strain,@spec,@dirn,$off);
    while (<$fh>) {
	chomp;
	if (/^>/) {
	    if (/^>(\S+) (\d+) /) {
		my ($spec,$pos) = ($1,$2);
		my ($str,undef,$c1,$c2) = split(/[-:]/,$spec);
		$strain[$pos] = $str;
		$spec[$pos] = $spec;
		$dirn[$pos] = $c1 < $c2 ? 'F' : 'C';
	    }
	} else {
	    $off ++;
	    my $i=2;
	    my $pMax;
	    my %quals;
	    for (my $p=0; $p<=$#strain; $p++) {
		if (defined $strain[$p]) {
		    my $v = substr($_,$i,1);
		    if ($v && $v ne ' ' && $v ne 'N' && $v ne 'n') {
			my $nqs = $v !~ /[a-z]/;
			$v =~ tr/=a-z/-A-Z/;
			my $qc = substr($_,$i+1,1);
			my $q = $qc eq ' ' ? 94 : ord($qc)-33;
			$pMax = $p;
			push @{$quals{$strain[$p]}{$dirn[$p]}{$v}},[$q,$nqs];
		    } else {
			$strain[$p] = $dirn[$p] = $spec[$p] = undef;
		    }
		}
		$i += 2;
	    }
	    while ($#strain > $pMax) {
		pop @strain;
		pop @dirn;
		pop @spec;
	    }
	    foreach my $str (keys %quals) {
		my $pH = $quals{$str};
		if (defined $pH->{F} && defined $pH->{C}) {
		    my %seen;
		    foreach my $dir (qw(F C)) {
			my $pH2 = $pH->{$dir};
			my @keys = sort keys %$pH2;
			my $init = 1;
			foreach my $v (@keys) {
			    if ($init) {
				$init = 0;
			    } else {
				print " , ";
			    }
			    my @qNQS;
			    foreach my $pA (@{$pH2->{$v}}) {
				push @{$qNQS[$pA->[1]]},$pA->[0];
			    }
			    print $v;
			    foreach my $nqs (1,0) {
				my $pA = $qNQS[$nqs];
				if ($pA) {
				    print " &" if ($nqs == 0);
				    print " " . join(" ",sort {$b <=> $a} @$pA);
				}
			    }
			    $seen{$v} = 1;
			}
			print " :: " if ($dir eq 'F');
		    }
		    if (keys %seen > 1) {
			print " :: $off $str";
			my $pfx = $str . '-';
			my $len = length($pfx);
			foreach my $p (0 .. $#strain) {
			    if (substr($spec[$p],0,$len) eq $pfx) {
				printf(" %s",substr($spec[$p],$len));
			    }
			}
		    }
		    print "\n";
		}
	    }
	}
		
    }
}
	
