#!/usr/bin/env perl

use Utility;
use strict;

foreach my $f (@ARGV) {
    if ($f =~ /^(.*)\.fa$/) {
	my $g = "$1.sz";
	deriveChrsz($f,$g) if (-s $f && ! -s $g);
    } else {
	print "Not a .fa file: $f\n";
    }
}

sub deriveChrsz {
    my ($f,$g) = @_;
    my $fh = openToRead($f);
    report("creating $g");
    my $gh = openToWrite($g);
    my ($chr,$sz);
    while (<$fh>) {
	chomp;
	if (/^>(.*)$/) {
	    print $gh "$chr $sz\n" if ($chr);
	    $chr = ($1 =~ /\.\d+$/) ? undef : $1;
	    $sz = 0;
	} else {
	    $sz += length($_);
	}
    }
    print $gh "$chr $sz\n" if ($chr);
    $gh->close();
    report();
}
