#!/usr/bin/env perl

# Arg: dir(s) containing layout.gz file

use Utility;
use strict;

foreach my $d (@ARGV) {
    disagreementRatesInLayout("$d/layout.gz","$d/dril.txt");
}

sub disagreementRatesInLayout {
    my ($f,$g) = @_;
    return unless (-s $f && stamp($g));
    report("$g: creating");
    my $fh = openToRead($f);
    my $gh = openToWrite($g);
    my (@name,@agr,@dis,@start);
    my $line = 0;
    while (<$fh>) {
	chomp;
	$line ++;
	if (/^>(\S+) (\d+) /) {
	    my ($r,$col) = ($1,($2+1)*2);
	    if (defined $name[$col]) {
		my $n = $agr[$col]+$dis[$col];
		printf($gh "%4d %4d %8.6f %s %d\n",
		       $dis[$col],$n,$dis[$col]/($n||1),$name[$col],$start[$col]);
		$agr[$col]=$dis[$col]=0;
	    }
	    $name[$col] = $r;
	    $start[$col] = $line;
	} else {
	    my $max = length($_);
	    my $r = substr($_,0,1);
	    if ($r =~ /[A-Z]/) {
		tr/a-z/A-Z/;
		for (my $col=2; $col<$max; $col+=2) {
		    my $s = substr($_,$col,1);
		    if ($s =~ /[A-Z]/) {
			if ($s eq $r) {
			    $agr[$col] ++;
			} else {
			    $dis[$col] ++;
			}
		    }
		}
	    }
	}
    }
    foreach my $col (2 .. $#name) {
	if (defined $name[$col]) {
	    my $n = $agr[$col]+$dis[$col];
	    printf($gh "%4d %4d %8.6f %s %d\n",
		   $dis[$col],$n,$dis[$col]/($n||1),$name[$col],$start[$col]);
	}
    }
    unstamp($g);
    report();
}
    
