#!/usr/bin/env perl

use Utility;
use strict;

my ($spec,$meth,$set) = @ARGV;

my $f = "$ENV{SGR}/match/$set/$spec/$meth/001/snpMatrix/sorted.q40";
my $fh = openToRead($f);
my @mat;
while (<$fh>) {
    chomp;
    my @a = split;
    push @mat,\@a;
}

# Find off-diagonal mean and SD
my ($sum,$sum2);
for (my $i=0; $i<$#mat; $i++) {
    for (my $j=$i+1; $j<=$#mat; $j++) {
	my $d = $mat[$i][$j];
	$sum += $d;
	$sum2 += $d*$d;
    }
}
my $n = $#mat*($#mat+1)/2;
my $mu = $sum/$n;
my $sd = sqrt($sum2/$n-$mu*$mu);
printf("%6s %8s %9s Count %3d Mean %8.6f SD %8.6f SD/Mean %8.6f",
       $spec,$meth,$set,$#mat+1,$mu,$sd,$sd/$mu);
# Boxes: <= 0.01, <= 0.1, <= 0.5, <= 1, > 1.
my @th = (0.01, 0.1, 0.5, 1, 1000000);
my @box;
my @rList;
foreach my $pA (@mat) {
    my @vals = sort {$a <=> $b} @$pA;
    my $min = $vals[1]; # since diag will be $vals[0];
    push @rList,$min/$mu;
}
@rList = sort {$a <=> $b} @rList;

foreach my $r (@rList) {
    foreach my $b (0 .. $#th) {
	if ($r <= $th[$b]) {
	    $box[$b] ++;
	    last;
	}
    }
}
foreach my $b (0 .. $#box) {
    printf("; %2d%%<=%4.2f",int(0.5+100*$box[$b]/($#mat+1)),$th[$b]);
}
print "\n";
foreach my $i (0 .. $#rList) {
    printf("%5.3f %5.3f\n",$rList[$i],$i/scalar(@rList));
    printf("%5.3f %5.3f\n",$rList[$i],($i+1)/scalar(@rList));
}

    
