#!/usr/bin/env perl

# Input: output of alicat.pl -i S, for a given single strain S

use strict;

my @divs;
my $sum = 0;
my $nSpace = 0;

my $chunkSize = 32;

<>; # header
while (<>) {
    #print;
    my $off = substr($_,0,12);
    next if ($off =~ /\./);
    my $r = substr($_,17,1);
    my $v = substr($_,19,1);
    $r =~ tr/_a-z/-A-Z/;
    $v =~ tr/_a-z/-A-Z/;
    $r =~ s/[0-9]/-/;
    $v =~ s/[0-9]/-/;
    my $qc = substr($_,20,1);
    if (scalar(@divs) == $chunkSize) {
	my $d = shift @divs;
	if ($d > 0) {
	    $sum -= $d;
	} else {
	    $nSpace --;
	}
    }
    my $d;
    if ($v eq ' ') {
	$d = -1;
	$nSpace ++;
    } elsif ($r eq $v) {
	$d = exp(log(0.1)*0.1*(ord($qc)-33));
	$sum += $d;
    } else {
	$d = 1;
	$sum += $d;
    }
    push @divs,$d;
    if (scalar(@divs) == $chunkSize) {
	printf("%7d %s\n",$off,$nSpace ? 'NA' : sprintf("%9.6f",$sum));
    }
}
