#!/usr/bin/env perl

# Args: column to extract, then e.g. imputed file(s)

use Utility;
use strict;

my $col = shift @ARGV;
my %count;
foreach my $f (@ARGV) {
    my $fh = openToRead($f);
    <$fh>; # header
    while (<$fh>) {
	$count{substr($_,$col,1)} ++;
    }
}

my ($num,$den);
my @keys = sort {$a cmp $b} keys %count;
if ($keys[0] eq ' ') {
    shift @keys;
    push @keys,' ';
}
foreach my $ch (@keys) {
    my $q = ($ch eq ' ' ? 128 : ord($ch)) - 33;
    my $pe = exp(-$q*log(10)*0.1);
    my $exp = $pe*$count{$ch};
    printf("%s %6.2f %8d\n",$ch,$exp,$count{$ch});
    $num += $exp;
    $den += $count{$ch};
}
printf("  %6.2f %8d\n",$num,$den);
