#!/usr/bin/env perl

use Utility;
use strict;

foreach my $f (glob("*/sequenced.gz"),glob("p?/*/sorted*gz")) {
    my $g = $f;
    $g =~ s/\.gz/_ext.gz/;
    if (stamp($g)) {
	report("$g: creating");
	my $fh = openToRead($f);
	my $gh = openToWrite($g);
	chomp (my $hdr = <$fh>);
	print $gh "$hdr\n";
	my @strains = split(" ",$hdr);
	my $tgtLen = 2*(scalar(@strains)+1);
	while (<$fh>) {
	    chomp;
	    my $d = $tgtLen - length($_);
	    if ($d > 0) {
		$_ .= ' ' x $d;
	    } elsif ($d < 0) {
		die("Line too long by $d: $_");
	    }
	    print $gh "$_\n";
	}
	unstamp($g);
	report();
    }
}
	    
