#!/usr/bin/env perl

use XML::Simple;

my $XS = new XML::Simple();

my %OPTS = (KeepRoot => 1, ForceArray => 1, KeyAttr => []);

foreach my $f (@ARGV) {
    extractElementOrderings($XS->XMLin($f,%OPTS));
}

sub extractElementOrderings {
    my ($pXML,$elem,@chain) = @_;
    my $t = ref $pXML;
    if ($t eq 'ARRAY') {
	foreach my $pH (@$pXML) {
	    extractElementOrderings($pH,$elem,@chain);
	}
    } elsif ($t eq 'HASH') {
	foreach my $key (keys %$pXML) {
	    if ($key eq 'xs:element') {
		$elem = $pXML->{$key}[0]{name} || 'noName';
	    } elsif ($key eq 'xs:complexType') {
		$elem = 'complex';
	    } elsif ($key eq 'xs:sequence') {
		extractElementOrdering($elem,$pXML->{$key});
	    }
	    extractElementOrderings($pXML->{$key},$elem,$key,@chain);
	}
    }
}

sub extractElementOrdering {
    my ($parent,$pElts) = @_;
    foreach my $pH (@$pElts) {
	my @names;
	foreach my $pH2 (@{$pH->{'xs:element'}}) {
	    push @names,$pH2->{name};
	}
	printf("%s :: %s\n",$parent,join(" ",@names));
    }
}
