#!/usr/bin/env perl

use Utility;
use strict;

extractPairwiseAlignments(@ARGV);

sub extractPairwiseAlignments {
    my ($d,@parts) = @_;
    foreach my $p (@parts) {
	foreach my $sub (glob("$d/p$p/*")) {
	    extractPairwiseAlignments1($sub);
	}
    }
}

sub extractPairwiseAlignments1 {
    my ($dir) = @_;
    my $base = "imputed_y.gz";
    my $src = "$dir/$base";
    return unless (-s $src && ! -f "$src.touch");
    my $tgtDir = "$dir/byStrain";
    return if (-d $tgtDir);
    report("creating $tgtDir/*/$base");
    my $fh = openToRead($src);
    my $hdr = <$fh>;
    chomp $hdr;
    my @out;
    foreach my $s (split(" ",substr($hdr,1))) {
	my $gh = openToWrite("$tgtDir/$s/$base");
	push @out,$gh;
	print $gh ">$s\n";
    }
    while (<$fh>) {
	chomp;
	my $r = substr($_,0,1);
	$r = '-' if ($r eq '=');
	my $col = 2;
	foreach my $gh (@out) {
	    my $v = substr($_,$col,1);
	    my $q = substr($_,$col+1,1);
	    $v =~ tr/=_/--/;
	    unless ($r eq '-' && $v eq '-') {
		print $gh "$r $v$q\n";
	    }
	    $col += 2;
	}
    }
    report();
}
