#!/usr/bin/env perl

# Args: file of read names, and list of fastq files containing the reads.
# Output to stdout: the named reads.

use Utility;
use strict;

my $rFile = shift @ARGV;

my %want;
my $fh = openToRead($rFile);
while (<$fh>) {
    chomp;
    $want{$_} = 1;
}

my $i = 0;
my $active = 0;
while (<>) {
    if ($i == 0) {
	my ($r) = split(" ",substr($_,1),2);
	$active = $want{$r};
	delete $want{$r} if ($active);
    }
    print if $active;
    $i = ($i == 3) ? 0 : $i+1;
}
foreach my $r (sort keys %want) {
    print STDERR "WARNING: did not find $r\n";
}
