#!/usr/bin/env perl

use Utility;
use strict;

my @WEIRD = qw(L_1528-8 YJM978-14 YS9-20 YJM981-18 
               CBS432-25 CBS432-27 CBS432-29 UFRJ50816-15 N_17-32.p A12-29.p);
my %IS_WEIRD;
foreach my $plate (@WEIRD) {
    my ($pl,$pq) = split(/\./,$plate);
    foreach my $p (qw(p q)) {
	unless ($pq && $p ne $pq) {
	    $IS_WEIRD{$pl}{$p} = 1;
	}
    }
}

my %nFound;
my %rejected;

foreach my $s (qw(cere para)) {
    (my $u = $s) =~ tr/a-z/A-Z/;
    my $f = "$ENV{SGR}/match/$u/$s/methc/rft.txt";
    my $fh = openToRead($f);
    while (<$fh>) {
	if (/4$/) {
	    my ($read) = split;
	    my ($plate,$pq) = ($read =~ /^(.*[0-9])[a-z].*([pq])1k$/);
	    if ($IS_WEIRD{$plate}{$pq}) {
		$nFound{$plate} ++;
		$rejected{$read} = 1;
	    }
	}
    }
}

my %want;
foreach my $w (@WEIRD) {
    $w =~ s/\.[pq]$//;
    unless ($nFound{$w}) {
	die("No suspicious reads found for $w\n");
    }
    $w =~ s/-.*//;
    $want{$w} = 1;
    #printf("%13s %3d\n","$w,$nFound{$w});
}

foreach my $str (sort keys %want) {
    my $fh = openToRead("$ENV{SGR}/read/$str/renamed.fastq");
    my $active;
    while (<$fh>) {
	if (/^\@(\S+)/) {
	    if ($rejected{$1}) {
		print ">$1\n";
		my $seq = <$fh>;
		print $seq;
	    }
	}
	print if ($active);
    }
}
