#!/usr/bin/env perl

# Run from align directory

use Utility;
use strict;

my %translate = qw(reject_close 0
		   reject_bisr 1
		   reject_bad_break 2
		   ambiguous_tel 3
		   ambiguous_trans 4
		   ambiguous_trans_ua 5
		   ambiguous 6
		   manual 7);

printf("%13s Count Close  BISR BadBr Telom Trans TrnUA Ambig Manual\n",'');
my @tot;
my $all;
foreach my $d (".",glob("*")) {
    my $f = "$d/clusters.txt";
    if (-s $f) {
	my $fh = openToRead($f);
	my @count;
	while (<$fh>) {
	    chomp;
	    my (undef,$c0,$reason) = split;
	    if ($c0 eq 'c0') {
		my $trans = $translate{$reason};
		$count[$trans] ++ if (defined $trans);
	    }
	}
	my $sum = 0;
	foreach my $i (0 .. $#count) {
	    $sum += $count[$i];
	    $tot[$i] += $count[$i];
	}
	$all += $sum;
	printLine($d,$sum,@count);
    }
}
printLine('ALL',$all,@tot);

sub printLine {
    my ($d,$sum,@count) = @_;
    printf("%13s %5d",$d,$sum);
    foreach my $i (0 .. 7) {
	printf(" %5.1f",100*$count[$i]/$sum);
    }
    print "\n";
}
