#!/usr/bin/env perl

use Utility;
use File::Basename;
use strict;

my ($srcD) = @ARGV;

my @pe;
foreach my $q (0 .. 94) {
    $pe[$q] = exp(-log(10)*$q/10);
}

my %rate;
foreach my $f (glob("$srcD/*.fastqcheck")) {
    my $b = basename($f,".fastqcheck");
    (my $r = $b) =~ s/_[1-8]$//;
    my $fh = openToRead($f);
    my @rate;
    while (<$fh>) {
	chomp;
	my ($tag,$pos,$a,$c,$g,$t,$n,@counts) = split;
	if ($tag eq 'base') {
	    my ($num,$den);
	    foreach my $i (0 .. $#counts-1) {
		$num += $counts[$i]*$pe[$i];
		$den += $counts[$i];
	    }
	    if ($den > 0) {
		$rate{$r}[$pos] = $rate{$b}[$pos] = $num/$den 
	    }
	}
    }
}
foreach my $b (sort keys %rate) {
    my $gh = openToWrite("$b.rate");
    my $pA = $rate{$b};
    foreach my $q (0 .. $#$pA) {
	if (defined $pA->[$q]) {
	    print $gh "$q $pA->[$q]\n";
	}
    }
}
