#!/usr/bin/env perl

# Args: outputs of segmentMatches.pl and blastOrSsahaToAlignedSegments.pl respectively

use Utility;
use strict;

my ($accFile,$asegFile) = @ARGV;

my %accept;
my $fh = openToRead($accFile);
<$fh>; # header
while (<$fh>) {
    chomp;
    s/^\s+//;
    my @a = split;
    if ($a[10] == 1) {
	push @{$accept{$a[9]}},[@a[11..14]];
    }
}

my $fh = openToRead($asegFile);
while (<$fh>) {
    chomp;
    my ($idx,$qchr,$offq,$fcq,$qlen,$schr,$offs,$fcs,$slen) = split;
    my ($qlo,$qhi,$slo,$shi);
    if ($fcq eq 'F') {
	$qlo = $offq;
	$qhi = $offq+$qlen-1;
    } else {
	$qhi = $offq;
	$qlo = $offq-$qlen+1;
    }
    if ($fcs eq 'F') {
	$slo = $offs;
	$shi = $offs+$slen-1;
    } else {
	$shi = $offs;
	$slo = $offs-$slen+1;
    }
    if (defined $accept{$idx}) {
	my @acc = @{$accept{$idx}};
	foreach my $pTup (@acc) {
	    my ($qmin,$qmax,$smin,$smax) = @$pTup;
	    next if ($qmax < $qlo || $qmin > $qhi || $smax < $slo || $smin > $shi);
	    my ($qloh,$qhih,$qlenh) = ($qlo,$qhi,$qlen);
	    if ($qlen > 0) {
		$qloh = max($qlo,$qmin);
		$qhih = min($qhi,$qmax);
		$qlenh = $qhih-$qloh+1;
	    }
	    my ($sloh,$shih,$slenh) = ($slo,$shi,$slen);
	    if ($slen > 0) {
		$sloh = max($slo,$smin);
		$shih = min($shi,$smax);
		$slenh = $shih-$sloh+1;
	    }
	    printf("%d %s %d %s %d %s %d %s %d\n",$idx,
		   $qchr,$fcq eq 'F' ? $qloh : $qhih,$fcq,$qlenh,
		   $schr,$fcs eq 'F' ? $sloh : $shih,$fcs,$slenh);
	}
    }
}
