#!/usr/bin/env perl

# Arg1: alilines for alignments to rDNA
# Run from read dir, so we can find $s/para/alilines.all.txt

use Utility;
use strict;

my %alis;
while (<>) {
    my (undef,undef,$read) = split;
    push @{$alis{$read}},$_;
}

my %wantStrain;
foreach my $r (keys %alis) {
    my ($str) = split(/-/,$r);
    $wantStrain{$str} = 1;
}

my %maxScore;
foreach my $str (sort keys %wantStrain) {
    my $fh = openToRead("$str/para/alilines.all.txt");
    while (<$fh>) {
	chomp;
	my (undef,$score,$read) = split;
	if (defined $alis{$read}) {
	    $maxScore{$read} = $score;
	}
    }
}

foreach my $r (sort keys %alis) {
    my $score = $maxScore{$r};
    my (undef,$rScore) = split(" ",$alis{$r}[0]);
    if ($rScore >= $score) {
	foreach my $line (@{$alis{$r}}) {
	    print $line;
	}
    }
}
