#!/usr/bin/env perl

# Input: alicoords.gz file

use Utility;
use strict;

my $fh = openToRead($ARGV[0]);
my (@segs,%isStart,%isEnd);
while (<$fh>) {
    my @a = split;
    for (my $i=4; $i<$#a; $i+=2) {
	my $lo = $a[$i];
	my $hi = $a[$i+1];
	push @segs,[$lo,$hi];
	$isStart{$lo} = $isEnd{$hi} = 1;
    }
}

# Delete starts not preceded by an end
foreach my $lo (keys %isStart) {
    unless ($isEnd{$lo-1}) {
	delete $isStart{$lo};
    }
}

my @starts = sort {$a <=> $b} keys %isStart;
foreach my $pSeg (sort {$a->[0] <=> $b->[0]} @segs) {
    my ($lo,$hi) = @$pSeg;
    while (@starts && $starts[0] <= $hi) {
	if ($starts[0] <= $lo) {
	    print $starts[0] . "\n";
	}
	shift @starts;
    }
}
