#!/usr/bin/perl

use Utility;
use strict;

foreach my $d (@ARGV) {
    my $f = "$d/layout.gz";
    my $g = "$d/fixed_layout.gz";
    if (! -s $f) {
	report("$f: does not exist",1);
    } elsif (-s $g) {
	report("$g: already exists",1);
    } else {
	report("$f: reading");
	my $fh = openToRead($f);
	my @lines = <$fh>;
	report();
	report("$f: fixing");
	foreach my $i (0 .. $#lines) {
	    next if (substr($lines[$i],0,1) eq '>');
	    my $len = length($lines[$i]);
	  KLOOP:
	    for (my $k=0; $k<$len; $k+=2) {
		if (substr($lines[$i],$k,1) eq '-') {
		    for (my $j=$i+1; $j<$i+20; $j++) {
			if (substr($lines[$j],$k,1) ne '-') {
			    next KLOOP;
			}
		    }
		    my $j=$i;
		    while ($j <= $#lines && substr($lines[$j],$k,1) eq '-') {
			substr($lines[$j],$k,1) = '=';
			$j++;
		    }
		}
	    }
	}
	report();
	report("$g: writing");
	my $gh = openToWrite("$d/fixed_layout.gz");
	print $gh @lines;
	$gh->close();
	report();
    }
}
