#!/usr/bin/env perl

use Utility;
use strict;

foreach my $d (@ARGV) {
    if (-d $d && substr($d,0,4) eq '000/') {
	fixLayoutIterationNumbers(substr($d,4));
    }
}

sub fixLayoutIterationNumbers {
    my ($dir) = @_;
    my %iter;
    foreach my $sub (glob("[0-9][0-9][0-9]")) {
	next if ($sub eq '000');
	my $i = $sub+0;
	my $d = "$sub/$dir";

	my $al = "$d/alilines.nola.txt";
	if (-s $al) {
	    my $fh = openToRead($al);
	    while (<$fh>) {
		chomp;
		my @a = split;
		$iter{$a[2]} = $i;
	    }
	}

	foreach my $b (qw(layout layout1 rqpw)) {
	    my $f = "$d/$b.gz";
	    my $g = "$d/${b}FIXED.gz";
	    if (isComplete($f) && (! -s "$f.sv1") && stamp($g)) {
		my $fh = openToRead($f);
		report("$g: creating");
		my $gh = openToWrite($g);
		while (<$fh>) {
		    if (/^>([^ :]+)(:\S+) (\d+) (\S+)$/) {
			chomp;
			my ($read,$range,$col,$mstr) = ($1,$2,$3,$4);
			if ($mstr =~ /^M/) {
			    my $it = $iter{$read};
			    die("No iteration for $read in $f") unless (defined $it);
			    print $gh ">$read$range $col $it\n";
			} else {
			    print $gh "$_\n";
			}
		    } else {
			print $gh $_;
		    }
		}
		$gh->close();
		unstamp($g);
		report();
	    }
	}
    }
}
