#!/usr/bin/perl

# Arg: Fregene file e.g. $SGR/rin10k_simII.xml.gz

use Utility;
use strict;

my $f = $ARGV[0];
(my $g = $f) =~ s/xml.gz$/mafs.gz/;
if ($g eq $f) {
    die("Usage: $0 FOO.xml.gz; will create FOO.mafs.gz\n");
}
my $fh = openToRead($f);
my %count;
my %firstVaries;
my $nIndivs;
while (<$fh>) {
    chomp;
    if (/^<DATA>/) {
	addToCounts(substr($_,6),\%count);
	%firstVaries = map {$_ => 1} keys %count;
	$nIndivs ++;
	last;
    }
}
while (<$fh>) {
    last if (/^<\/DATA>/);
    chomp;
    addToCounts($_,\%count);
    $nIndivs ++;
}
my $gh = openToWrite($g);
foreach my $off (sort {$a <=> $b} keys %count) {
    my $prop = $count{$off}/$nIndivs;
    $prop = 1-$prop if ($firstVaries{$off});
    printf($gh "%d %12.10f\n",$off,$prop);
}
$gh->close();

sub addToCounts {
    my ($line,$pCount) = @_;
    foreach my $n (split(" ",$line)) {
	$pCount->{$n} ++ if ($n > 0);
    }
}
