#!/usr/bin/env perl

# Args: contig name, chr name, file(s) with ALIGNMENT lines

use GD::Simple;
use Utility;
use strict;

my $MIN_SCORE = 100;

my ($cont,$chr);
($cont,$chr,@ARGV) = @ARGV;

my @quads;
my ($qMin,$qMax,$sMin,$sMax);
while (<>) {
    chomp;
    my ($key,$score,$contig,$chrom,$qLo,$qHi,$sLo,$sHi) = split;
    if ($contig eq $cont && $chrom eq $chr && $score >= $MIN_SCORE) {
	push @quads,[$qLo,$qHi,$sLo,$sHi,$score];
	$qMin = min($qMin,$qLo);
	$qMax = max($qMax,$qHi);
	$sMin = min($sMin,$sLo);
	$sMax = max($sMax,$sHi);
    }
}

my $xSz = 1000;
my $ySz = 700;
my $xScale = $xSz/($sMax-$sMin+1);
my $yScale = $ySz/($qMax-$qMin+1);
my $im = new GD::Simple($xSz,$ySz);
foreach my $pQ (@quads) {
    my ($qLo,$qHi,$sLo,$sHi,$score) = @$pQ;
    print "@$pQ\n";
    $im->moveTo(($sLo-$sMin)*$xScale,
		$ySz-($qLo-$qMin)*$yScale);
    $im->lineTo(($sHi-$sMin)*$xScale,
		$ySz-($qHi-$qMin)*$yScale);
    $im->moveTo((($sHi+$sLo)/2-$sMin)*$xScale,
		$ySz-(($qLo+$qHi)/2-$qMin)*$yScale);
    $im->string($score);
}
my $gh = openToPipe("display");
binmode $gh;
print $gh $im->png;
