#!/usr/bin/env perl

use Utility;
use strict;

# Follows on from geneCoverageTable.pl.

my $fh = openToRead("match/geneCoverageTable.txt");
chomp (my @lines = <$fh>);
my (%gCovs,%sCovs);
foreach my $line (@lines) {
    my ($g,$s,undef,$cov) = split(" ",$line);
    push @{$gCovs{$g}},$cov;
    push @{$sCovs{$s}},$cov;
}

my (%sMed,%gMed);
foreach my $s (keys %sCovs) {
    my @a = sort {$a <=> $b} @{$sCovs{$s}};
    my $mid1 = int($#a/2);
    my $mid2 = int(($#a+1)/2);
    $sMed{$s} = ($a[$mid1]+$a[$mid2])/2;
}
foreach my $g (keys %gCovs) {
    my @a = sort {$a <=> $b} @{$gCovs{$g}};
    my $mid1 = int($#a/2);
    my $mid2 = int(($#a+1)/2);
    $gMed{$g} = ($a[$mid1]+$a[$mid2])/2;
}

print "     Gene  GeneMed         Strain  StrMed   Min    Mean Max   Mean/SM  Mean/SMGM\n";

foreach my $line (@lines) {
    my ($g,$s,$min,$cov,$max) = split(" ",$line);
    my $gm = max($gMed{$g},1);
    my $sm = $sMed{$s};
    printf("%10s %7.2f  %13s %7.2f   %3d %7.2f %3d   %7.2f  %7.2f\n",
	   $g,$gMed{$g},$s,$sm,$min,$cov,$max,$cov/$sm,$cov/($sm*$gm));
}

