#!/usr/bin/env perl

# For (corrected) "Data submitted by Sanger" table in G1K presentation 17-4-08

use Utility;
use strict;

my $fh = openToRead("$ENV{HOME}/sgrp/g1k/SRA/20080415/g1k-sc-20080415-1.runs.csv");
my (%lanes,%bases);
<$fh>; # header
while (<$fh>) {
    chomp;
    s/^"//;
    s/"$//;
    my @a = split(/","/,$_);
    my $nLanes = $a[5];
    my $alias = $a[6];
    my @b = split(/-/,$alias);
    my $indiv = $b[2];
    my $nBases = $a[8];
    $lanes{$indiv} += $nLanes;
    $bases{$indiv} += $nBases;
}
foreach my $ind (sort keys %lanes) {
    my $gb = $bases{$ind}/1000000000;
    printf("%s %2d %6.3f %5.3f\n",$ind,$lanes{$ind},$gb,$gb/$lanes{$ind});
}
