#!/usr/bin/env perl

# Args: chr offset foo.gff, or chr lo..hi foo.gff

use Utility;
use strict;

my ($chr,$off,$f) = @ARGV;

my ($lo,$hi) = split(/\.\./,$off);
$hi = $hi || $lo;

my $fh = openToRead($f);
my @mat;
while (<$fh>) {
    chomp;
    my @a = split;
    push @mat,\@a if ($a[0] eq $chr && $a[3] <= $lo && $a[4] >= $hi);
}
if (@mat) {
    my @maxL;
    foreach my $pA (@mat) {
	foreach my $i (0 .. $#$pA) {
	    $maxL[$i] = max($maxL[$i],length($pA->[$i]));
	}
    }
    foreach my $pA (@mat) {
	foreach my $i (0 .. $#$pA) {
	    print " " if ($i>0);
	    if ($i == $#$pA) {
		print substr($pA->[$i],0,30) . "\n";
	    } else {
		my $v = $pA->[$i];
		unless ($v =~ /^\d+$/) {
		    $v .= ' ' x ($maxL[$i]-length($v));
		}
		my $fmt = "%" . $maxL[$i] . ($v =~ /^\d+$/ ? 'd' : 's');
		printf($fmt,$v);
	    }
	}
    }
}
