#!/usr/bin/env perl

use Utility;
use File::Basename;
use strict;

my @count;
my @strains;
foreach my $f (glob("*.qd")) {
    my $s = basename($f,".qd");
    push @strains,$s;
    my $fh = openToRead($f);
    <$fh>; # header
    while (<$fh>) {
	chomp;
	my ($q,$prop) = split;
	# Group qualities into threes...
       $q = 3*int($q/3)+1;
	$count[$q]{$s} += $prop;
    }
}
print "  q";
foreach my $s (@strains) {
    printf(" %12s",$s);
}
print "\n";
for (my $q=1; $q<=$#count; $q+=3) {
    printf("%3d",$q);
    my $pH = $count[$q];
    foreach my $s (@strains) {
	printf(" %12.10f",$pH->{$s});
    }
    print "\n";
}
