#!/usr/bin/env perl

use Utility;
use File::Basename;
use strict;

chdir("$ENV{SGR}/match");

printf("%3s","");
foreach my $n (qw(1 2 3 6 12 24 50 100 200)) {
    printf(" & %4d",$n);
}
print " \\\\ \\hline\n";
foreach my $c (qw(0 1 2 4 8)) {
    printf("%3.1f",$c || 0.5);
    foreach my $n (qw(1 2 3 6 12 24 50 100 200)) {
	my $d = "FREG${n}_$c/freg";
	my $src1 = "$d/cia_chrs_errs_complete_mac0/cia.chr00.bout";
	my $src2 = "$d/cia_chrs_errs_complete_mac0:0.50/cia.chr00.bout";
        my $tgt = "$d/sum.txt";

	if (-s $src1 && -s $src2 && ! -s $tgt) {
	    `sumCompareImputedAcross.pl $src1 $src2 > $tgt`;
	}

	if (-s $tgt) {
	    my $fh = openToRead($tgt);
	    while (<$fh>) {
		if (substr($_,0,4) eq '... ') {
		    my @a = split;
		    my $rate = $a[-2]*1000000;
		    printf(" & %4d",int($rate+0.5));
		}
	    }
	} else {
	    printf(" & %4s","");
	}
    }
    print " \\\\ \\hline\n";
}
