#!/usr/bin/env perl

use Utility;
use strict;

my @slope = (undef,2.13354,2.68949,2.68067);
my @const = (undef,-3.18592,-0.43062,0);

foreach my $n (1 .. 3) {
    my $gh = openToWrite("fit${n}_0.xy");
    for (my $s=0.1; $s<15.2; $s+=0.2) {
	my $q = $slope[$n]*$s + $const[$n];
	my $pe = max(0,min(1,exp(-0.1*log(10)*$q)));
	printf($gh "%3.3f %8.6f\n",$s,1-$pe);
    }
}
