#!/usr/bin/env perl

# Input: output of indelSpectrum.pl

use Utility;
use strict;

my $FAC = 2;

my %SUM;
while (<>) {
    chomp;
    my ($str,$type,$len,$count,undef,$nCount) = split;
    my $lo = int(0.5+exp(log($FAC)*int(log($len)/log($FAC))));
    #my $hi = $lo*$FAC-1;
    my $pA = $SUM{$str}{$type}{$lo};
    if ($pA) {
	my ($c,$p,$nc,$np)  = @$pA;
	$SUM{$str}{$type}{$lo} = [$c+$count,$nc+$nCount];
    } else {
	$SUM{$str}{$type}{$lo} = [$count,$nCount];
    }
}

foreach my $str (sort keys %SUM) {
    foreach my $type (qw(mch ins del)) {
	my $pH = $SUM{$str}{$type};
	my ($sum1,$sum2)=(0,0);
	foreach my $lo (keys %$pH) {
	    my ($v1,$v2) = @{$pH->{$lo}};
	    $sum1 += $v1;
	    $sum2 += $v2;
	}
	foreach my $lo (sort {$a <=> $b} keys %$pH) {
	    my ($v1,$v2) = @{$pH->{$lo}};
	    printf("%s %s %6d %6d %7d %8.6f %9d %8.6f\n",
		   $str,$type,$lo,$lo*$FAC-1,
		   $v1,$v1/$sum1,$v2,$v2/$sum2);
	}
    }
}

    
