#!/usr/bin/env perl

# Input: accepted-alignment file(s), e.g. alilines.nola.txt in 000 directory.

use strict;
my (%bad,%low,%high);
while (<>) {
    chomp;
    my (undef,undef,$r,$chr,$rlo,$rhi,$clo,$chi,$fc,undef,undef,$rlen) = split;
    my ($ins,$pq) = ($r =~ /^(.*)\.([pq])1k$/);
    my @comps = split(/\./,$chr);
    if ($bad{$ins} || (@comps > 2)) {
	$bad{$ins} = 1; # ignore
    } elsif ($fc eq 'F') {
	if (defined $low{$ins}) {
	    $bad{$ins} = 1;
	} else {
	    $low{$ins} = $clo+1-$rlo;
	}
    } elsif ($fc eq 'C') {
	if (defined $high{$ins}) {
	    $bad{$ins} = 1;
	} else {
	    $high{$ins} = $chi+$rlen-$rlo;
	}
    }
}

foreach my $ins (sort keys %low) {
    if (defined $high{$ins} && !defined $bad{$ins}) {
	my $sz = $high{$ins}-$low{$ins}+1;
	if ($sz > 0 && $sz < 20000) {
	    printf("%s %5d\n",$ins,$sz);
	}
    }
}

