#!/usr/bin/perl

use Utility;
use strict;

# Args: one or more of 1 2 3 4

chdir("$ENV{SGR}/match");

my @METH_NAME = qw(undef dumb static MF oracle);

my (%isNH,%isCov);
foreach my $dir (glob("FREG*_?")) {
    my ($nh,$cov) = ($dir =~ /^FREG(\d+)_(\d+)$/);
    if ($nh) {
	$isNH{$nh} = 1;
	$isCov{$cov} = 1;
    }
}

my @nhList = sort {$a <=> $b} keys %isNH;
my @covList = sort {$a <=> $b} keys %isCov;

foreach my $t qw(noerrs errs) {
    foreach my $meth (@ARGV) {
	my $name = $METH_NAME[$meth] || die("Must provide method number 1 to 4");
	printf("\nPer-million overall error rates for %s method, SE%s\n",
	       $name,$t eq 'errs' ? '+' : '-');
	print "Cov  ";
	foreach my $nh (@nhList) {
	    printf("     NH=%3d",$nh);
	}
	print "\n";
	foreach my $cov (@covList) {
	    printf("%3.1f  ", $cov || 0.5);
	    foreach my $nh (@nhList) {
		my $f = "FREG${nh}_$cov/freg/cia_chrs_${t}_complete/sum.txt";
		if (-s $f) {
		    my $fh = openToRead($f);
		    while (<$fh>) {
			my @a = split;
			if ($a[0] eq '...') {
			    printf(" %10.2f",$a[$meth+2]*1000000);
			    last;
			}
		    }
		} else {
		    printf(" %10s","");
		}
	    }
	    print "\n";
	}
    }
}
