#!/usr/bin/env perl

use Utility;
use strict;

# Make (the first line of) a fastqcheck file for each fastq[.gz] argument.

foreach my $f (@ARGV) {
    if ($f =~ /\.fastq$/ || $f =~ /\.fastq\.gz$/) {
	makeFastqcheck($f);
    } else {
	report("does not finish in .fastq[.gz]: $f",1);
    }
}

sub makeFastqcheck {
    my ($f) = @_;
    my $g = $f;
    $g =~ s/\.gz//;
    $g .= 'check';
    if (stamp($g)) {
	report("$g: creating");
	my $fh = openToRead($f);
	my ($nseqs,$totlen,$max);
	while (<$fh>) {
	    $_ = <$fh>; # sequence line
	    chomp;
	    my $len = length($_);
	    $nseqs ++;
	    $totlen += $len;
	    $max = max($max,$len);
	    <$fh>;
	    <$fh>;
	}
	my $gh = openToWrite($g);
	printf($gh "%d sequences, %d total length, %4.2f average, %d max\n",
	       $nseqs,$totlen,$totlen/$nseqs,$max);
	report();
	unstamp($g);
    }
}
