#!/usr/bin/env perl

# See 2008 0104

use Utility;
use strict;

my @FATES = qw(ambiguous bad clashed context placed unaligned unsafe);
my %IS_FATE = map {$_ => 1} @FATES;

printf("%13s %4s","strain","sp");
foreach my $fate (@FATES) {
    printf(" %9s",$fate);
}
print "\n";
foreach my $sp (qw(cere para)) {
    (my $usp = $sp) =~ tr/a-z/A-Z/;
    my $rft = "$ENV{SGR}/match/$usp/$sp/methc/rft.txt";
    my $fh = openToRead($rft);
    my %c;
    while (<$fh>) {
	chomp;
	my @a = split;
	my ($str) = split(/-/,$a[0]);
	my $fate = $a[-1];
	if ($IS_FATE{$fate}) {
	    # OK
	} elsif ($fate eq 'never_aligned') {
	    $fate = 'unaligned';
	} elsif ($fate eq 'mediocre_read' || $fate eq 'bad_read') {
	    $fate = 'bad';
	} elsif ($fate eq 'unsafe_insertion') {
	    $fate = 'unsafe';
	} else { # discarded go here ...
	    $fate = 'context';
	}
	$c{$str}{$fate} ++;
	if (isAssembledRM11($a[0])) {
	    $c{"RM11_1A_As"}{$fate} ++;
	}
    }
    foreach my $str (sort keys %c) {
	my $pH = $c{$str};
	printf("%13s %4s",$str,$sp);
	foreach my $fate (@FATES) {
	    printf(" %9d",$pH->{$fate});
	}
	print "\n";
    }
}

sub isAssembledRM11 {
    my ($r) = @_;
    if ($r =~ /^RM11_1A-[3-9][0-9][a-z]/) {
	return ($r gt 'RM11_1A-36n16');
    } else {
	return 0;
    }
}
