#!/usr/bin/env perl

# Input: srf_manifest.txt file, created by sraFilesToXML.pl; or if none, calculate
# for everything in the DATA hierarchy.

use Utility;
use strict;

autoflush STDOUT 1;

my %wanted;
if (@ARGV) {
    while (<>) {
	chomp;
	$wanted{$_} = 1;
    }
}

my $DATA = '/lustre/thougen/thougen/DATA';

my (%count,%sum);
#report("searching data hierarchy");
foreach my $f (glob("$DATA/*-*/NA*/libSC*/*/*.fastq")) {
    my $g = readlink($f);
    (my $srf = $g) =~ s/fastq$/srf/;
    unless (%wanted && !$wanted{$srf}) {
	delete $wanted{$srf};
	$g .= 'check';
	if (-s $g) {
	    my $fh = openToRead($g);
	    chomp ($_ = <$fh>);
	    my (undef,undef,$sz) = split;
	    my (undef,undef,$lib,$indiv,$pop) = reverse(split(/\//,$f));
	    foreach my $key ("ALL",$pop,"$pop/$indiv","$pop/$indiv/$lib") {
		$count{$key} ++;
		$sum{$key} += $sz;
	    }
	}
    }
}
#report();

printf("%5s %8s %8s %s\n",
       "Lanes","Gbases","AvMbases","Node");
foreach my $key (sort keys %count) {
    printf("%5d %8.3f %8.3f %s\n",
	   $count{$key},
	   $sum{$key}/1000000000,
	   $sum{$key}/($count{$key}*1000000),
	   $key);
}
if (%wanted) {
    print "Failed to find the following SRF files through the hierarchy:\n";
    foreach my $key (sort keys %wanted) {
	print "$key\n";
    }
}
