#!/usr/bin/env perl

use Utility;
use Bsub;
use strict;

my @files = @ARGV;
@files = reverse(glob("*/*/*/*/*fastq")) unless (@files);

foreach my $f (@files) {
    my $md5 = $f;
    $md5 =~ s/fastq$/md5/;
    my $srf = readlink($f);
    $srf =~ s/fastq$/srf/;
    if (-s $srf) {
	if (-f $md5) {
	    if (newer($srf,$md5)) {
		report("deleting old $md5",1);
		unlink($md5);
	    } else {
		next;
	    }
	}
        report("creating $md5",1);
	bsub("tmp","md5sum -b $srf > $md5");
    }
}
    
