#!/usr/bin/env perl

use Utility;
use strict;

# Input: alicoords file

my (%lo,%hi);
my $fh = openToRead($ARGV[0]);
while (<$fh>) {
    chomp;
    my ($read,undef,$ori,undef,@coords) = split;
    (my $clone = $read) =~ s/\.[pq]1k$//;
    if ($ori > 0) {
	$lo{$clone} = $coords[0];
    } elsif ($ori < 0) {
	$hi{$clone} = $coords[-2];
    }
}

my (%dNum,%dDen);
foreach my $clone (keys %lo) {
    if (defined $hi{$clone}) {
	my $bot = $lo{$clone};
	my $top = $hi{$clone};
	my $len = $top-$bot+1;
	if ($len > 0 && $len < 20000) {
	    my ($str) = split(/-/,$clone);
	    $dNum{$str}{$bot} += $len;
	    $dDen{$str}{$bot} ++;
	    $dNum{$str}{$top+1} -= $len;
	    $dDen{$str}{$top+1} --;
	}
    }
}

foreach my $str (sort keys %dNum) {
    my $pDN = $dNum{$str};
    my $pDD = $dDen{$str};
    my ($num,$den) = (0,0);
    my @offs = sort {$a <=> $b} keys %$pDN;
    while (@offs > 1) {
	my $off = shift @offs;
	$num += $pDN->{$off};
	$den += $pDD->{$off};
	printf("%s %7d %7d %5d %3d\n",
	       $str,$off,$offs[0],$num/($den||1),$den);
    }
}

       
