#!/usr/bin/perl

use Utility;
use strict;

my @count;
foreach my $f (@ARGV) {
    my $fh = openToRead($f);
    <$fh>; # header
    while (<$fh>) {
	chomp;
	my $len = length($_);
	my (%c,%seen);
	my $type = 0;
	for (my $k=2; $k<$len; $k+=2) {
	    my $pair = substr($_,$k,2);
	    my $v = substr($pair,0,1);
	    unless ($v eq ' ') {
		$v =~ tr/a-z/A-Z/;
		$seen{$v} = 1;
		if ($pair =~ /^[ACGTacgt]/) {
		    my $q = substr($pair,1);
		    $c{$q} ++;
		} else {
		    $type = 2; # includes gaps
		}
	    }
	}
	$type = 1 if ($type == 0 && scalar(keys %seen) > 1);
	foreach my $q (keys %c) {
	    $count[$type]{$q} += $c{$q};
	}
    }
}

foreach my $type (0,1,2) {
    my ($num,$den);
    my $pC = $count[$type];
    foreach my $qc (keys %$pC) {
	my $q = ($qc eq ' ' ? 127 : ord($qc)) - 33;
	my $pe = exp(log(0.1)*$q/10);
	$num += $pC->{$qc}*$pe;
	$den += $pC->{$qc};
    }
    printf("Mean error prob for type %d = %10.8f from %8d cases\n",$type,$num/($den || 1),$den);
}
