#!/usr/bin/env perl

# Args: prefix for output file, then input files

use Utility;
use strict;

my $pfx = shift @ARGV || die("Usage: $0 outPfx renamed.fastq ...");

my $SLICE = 4;

my @out;
foreach my $i (0 .. $SLICE) {
    my $g = sprintf("%s.%2d",$pfx,$i);
    $g =~ tr/ /0/;
    $out[$i] = openToWrite($g);
}

my @c;
my $n=0;
while (<>) {
    $n++;
    if ($n == 4) {
	$n=0;
	chomp;
	my $iLim = length($_);
	foreach my $i (0 .. $iLim-1) {
	    my $q = ord(substr($_,$i,1))-33;
	    $c[$i][$q] ++;
	}
    }
}
foreach my $i (0 .. $#c) {
    my $pA = $c[$i];
    my $sum = 0;
    foreach my $q (0 .. $#$pA) {
	$sum += $pA->[$q];
    }
    if ($sum >= $SLICE*10) {
	my $fac = $sum/$SLICE;
	$sum = 0;
	my $id = -1;
	foreach my $q (0 .. $#$pA) {
	    if ($pA->[$q]) {
		$sum += $pA->[$q];
		my $qid = $q == $#$pA ? $SLICE : int($sum/$fac);
		while ($id < $qid) {
		    $id ++;
		    my $gh = $out[$id];
		    printf($gh "%3d %2d\n",$i,$q);
		}
	    }
	}
    }
}
