#!/usr/bin/env perl

use Utility;
use strict;

# Args: layout.gz file(s)

foreach my $f (@ARGV) {
    my $fh = openToRead($f);
    my @readAt;
    my %isRead;
    my %refAligned;
    while (<$fh>) {
	chomp;
	if (/^>REF/) {
	    # nothing
	} elsif (/^>(\S+) (\d+) \d+/) {
	    my $seg = $1;
	    my $pos = $2;
	    my ($read) = split(/:/,$seg);
	    $read =~ s/\.[pq]1k$//; # actually do this with CLONES
	    $isRead{$read} = 1;
	    $readAt[$pos] = $read;
	} elsif (/^[A-Z]/) {
	    my $posMax = length($_)/2-2;
	    while ($#readAt > $posMax) {
		pop @readAt;
	    }
	    foreach my $pos (0 .. $#readAt) {
		my $v = substr($_,($pos+1)*2,1);
		if ($v =~ /[A-Za-z]/) {
		    $refAligned{$readAt[$pos]} = 1;
		}
	    }
	}
    }
    foreach my $r (sort keys %isRead) {
	unless ($refAligned{$r}) {
	    print "$r.p1k\n";
	    print "$r.q1k\n";
	}
    }
}
