#!/usr/bin/perl

# Input: imputed[s].gz files (or probably better, sorted.gz)
# Outputs: nrco.fq in each dir

use Utility;
use File::Basename;
use strict;

foreach my $f (@ARGV) {
    my $dir = absoluteFileName(dirname($f));
    my $g = sprintf("%s/nrco.fq",$dir);
    if (-s $g) {
	report("$g: already exists",1);
    } else {
	report("$g: creating");
	my $fh = openToRead($f);
	my $gh = openToWrite($g);
	printf($gh ">%s\n",basename($dir));
	while (<$fh>) {
	    chomp;
	    if (/^[A-Z]/) {
		#tr/a-z/A-Z/;
		#s/[_=]/-/g;
		my %count;
		my $iMax = length($_)-2;
		for (my $i=2; $i<=$iMax; $i+=2) {
		    my $v = substr($_,$i,1);
		    $v =~ tr/a-z/A-Z/;
		    if ($v =~ /[A-Z]/) {
			my $qc = substr($_,$i+1,1);
			my $q = $qc eq ' ' ? 94 : ord($qc)-33;
			$count{$v} += $q;
		    }
		}
		my ($best,$snd) = sort {$count{$b} <=> $count{$a}} keys %count;
		if (!$best) {
		    print $gh substr($_,0,1) . "!\n";
		} else {
		    my $d = $count{$best} - $count{$snd};
		    my $qc = ($d >= 94) ? ' ' : chr($d+33);
		    print $gh "$best$qc\n";
		}
	    }
	}
	report();
    }
}
