#!/usr/bin/env perl

use Utility;
use strict;

foreach my $n (1 .. 258) {
    my $id = sprintf("AAFW02000%3d",$n);
    $id =~ tr/ /0/;
    pfetch($id);
}
pfetch('EU004203');

sub pfetch {
    my ($id) = @_;
    my $fa = "$id.fa";
    unless (-s $fa) {
	`pfetch $id > $fa`;
	report(sprintf("%s has size %7d",$id,-s $fa),1);
    }
}

unless (-s "genome.fa") {
    my $gh = openToWrite("genome.fa");
    foreach my $f (glob("[A-Z]*.fa")) {
	copyContig($f,$gh);
    }
}

sub copyContig {
    my ($f,$gh) = @_;
    my $fh = openToRead($f);
    my $line = <$fh>;
    chomp $line;
    my @a = split(" ",$line);
    my $name;
    if ($a[4] eq 'mitochondrion,') {
	$name = 'chrm';
    } else {
	my $chr = sprintf("chr%2d",$a[5]);
	my $cont = $a[6];
        $cont =~ s/.*Contig//;
	$name = sprintf("%s_%3d",$chr,$cont);
	$name =~ tr/ /0/;
    }
    print $gh ">YJM789-$name\n";
    while (<$fh>) {
	print $gh $_;
    }
}
