#!/usr/bin/env perl

use Utility;
use strict;

my $TOP = "/lustre/scratch1/sanger/dmc/sgroot/read";

foreach my $s (@ARGV) {
    my $f = "$TOP/$s/cere/alilines.all.txt";
    my $d = "$TOP/$s/cere/poor";
    my %want;
    if (-s $f && ! -d $d) {
	report("$d: creating");
	my $fh = openToRead($f);
	my $oldRead;
	while (<$fh>) {
	    chomp;
	    my (undef,$score,$read,@rest) = split;
	    if ($read ne $oldRead) {
		$oldRead = $read;
		if ($score < 0.1*$rest[-1] && ! /chrm/) {
		    $want{$read} = 1;
		}
	    }
	}
	my $fh = openToRead("$TOP/$s/renamed.fastq");
	my $active;
	while (<$fh>) {
	    if (/^@(\S+) /) {
		$active = $want{$1} ? $1 : undef;
	    } elsif ($active) {
		if (length($_) > 400) {
		    my $gh = openToWrite("$d/$active.fa");
		    print $gh ">$active\n";
		    print $gh $_;
		    $gh->close();
		}
		$active = 0;
	    }
	}
	report();
    }
}
