#!/usr/bin/env perl

use GD;
use GD::Simple;
use Utility;
use Getopt::Std;
use strict;

my @alis;
my ($xmin,$xmax,$ymin,$ymax);
while (<>) {
    chomp;
    my ($key,$score,$query,undef,undef,undef,$lo,$hi,undef,undef,$perc) = split;
    if ($perc >= 80) {
	($lo,$hi) = sort {$a <=> $b} ($lo,$hi);
	$query =~ s/[^0-9]//g;
	$query =~ s/^0+//;
	my $y = $query;
	push @alis,[$y,$lo,$hi];
	$ymin = min($y,$ymin);
	$ymax = max($y,$ymax);
	$xmin = min($lo,$xmin);
	$xmax = max($hi,$xmax);
    }
}

my ($xsz,$ysz) = (800,800);
my $im = new GD::Simple($xsz,$ysz);
foreach my $pA (@alis) {
    my ($q,$lo,$hi) = @$pA;
    my $m = ($hi+$lo)/2;
    my $col;
    if ($hi < 453042) {
	$col = 'black';
    } elsif ($lo > 453002) {
	$col = 'green';
    } else {
	$col = 'red';
    }
    $im->fgcolor($col);
    my $x1 = $xsz*($lo-$xmin)/($xmax-$xmin);
    my $x2 = $xsz*($hi-$xmin)/($xmax-$xmin);
    my $y = $ysz*($ymax-$q)/($ymax-$ymin);
    $im->moveTo($x1,$y);
    $im->lineTo($x2,$y);
}
my $gh = openToWrite("tmp.png");
binmode $gh;
print $gh $im->png;
$gh->close();
