#!/usr/bin/env perl

# Args: target directory; then source directories, or file containing source directory names

use Utility;
use File::Basename;
use strict;

my $tgtDir = shift @ARGV;
my $mani = "$tgtDir/SOURCES.txt";
my %SEEN;
if (-s $mani) {
    my $fh = openToRead($mani);
    while (<$fh>) {
	chomp;
	$SEEN{dirname($_)} = 1;
    }
}

my $gh = openToAppend($mani);
foreach my $fd (@ARGV) {
    if (-d $fd) {
	augmentStagingDirectory($gh,$tgtDir,$fd);
    } elsif (-s $fd) {
	my $fh = openToRead($fd);
	while (<$fd>) {
	    chomp;
	    augmentStagingDirectory($gh,$tgtDir,$_);
	}
    }
}

sub augmentStagingDirectory {
    my ($gh,$tgtDir,$srcDir) = @_;
    unless (-d $srcDir) {
	report("$srcDir: no such directory",1);
	return;
    }
    foreach my $f (glob("$srcDir/*")) {
	if ($f =~ /(fastq|fastqcheck|_srf.md5)$/) {
	    print $gh "$f\n";
	    my $b = basename($f);
	    report("$f: copying first four lines");
	    `head -4 $f > $tgtDir/$b`;
	    report();
	}
    }
}
