#!/usr/bin/env perl

# Args: strain names

use Utility;
use strict;

my $MAX_SLACK = 10;
my $MIN_SCORE = 100;
my $MAX_SHORTFALL = 50;

my $gh = openToPipe("sort");
foreach my $s (sort @ARGV) {
    my $aFile = "$ENV{SGR}/read/$s/cere/alilines.all.txt";
    my $pFile = "$s.ptbs";
    possibleTransposonInsertions($aFile,$pFile,$gh);
}

sub possibleTransposonInsertions {
    my ($aFile,$pFile,$gh) = @_;
    my %ptb;
    my $fh = openToRead($pFile);
    while (<$fh>) {
	chomp;
	my ($read,@reg) = split;
	$ptb{$read} = \@reg;
    }
    my $fh = openToRead($aFile);
    my ($curRead,$curTh);
    $curTh = $MIN_SCORE;
    while (<$fh>) {
	chomp;
	my (undef,$score,$read,$chr,$rlo,$rhi,$clo,$chi,$fc) = split;
	# No aux sequences and no chrm or scplasm1:
	next unless (defined $ptb{$read} && $chr =~ /chr..$/);
	unless ($read eq $curRead) {
	    $curRead = $read;
	    $curTh = max($MIN_SCORE,$score-$MAX_SHORTFALL);
	}
	next if ($score < $curTh);
	($rlo,$rhi) = sort {$a <=> $b} ($rlo,$rhi);
	($clo,$chi) = sort {$a <=> $b} ($clo,$chi);
	my ($regLo,$regHi,$teId,$teFC) = @{$ptb{$read}};
	my ($off,$dir);
	if ($regLo == 1) {
	    my $d = $regHi-$rhi;
	    next if (abs($d) > $MAX_SLACK);
	    $off = ($fc eq 'F') ? $chi+$d : $clo-1-$d;
	    $dir = 'R';
	} else {
	    my $d = $regLo-$rlo;
	    next if (abs($d) > $MAX_SLACK);
	    $off = ($fc eq 'F') ? $clo-1+$d : $chi-$d;
	    $dir = 'L';
	}
	printf($gh "%s %7d %s %s %s %s\n",$chr,$off,$dir,$teId,$fc eq $teFC ? 'F' : 'C',$read);
    }
}

