#!/usr/bin/env perl

use Getopt::Std;
use strict;

my %OPT = (s => 60);

getopts('s:',\%OPT);

my ($tgtSz,$file) = @ARGV;

my $SECS = $OPT{s};

my ($origSz,$origTime,$oldSz);
while (1) {
    my $sz = -s $file;
    my $perc = 100*$sz/$tgtSz;
    my $now = time();
    printf("%s: %6.2f%% done",scalar(localtime($now)),$perc);
    if ($sz >= $tgtSz || $sz == $oldSz) {
	print "\n";
	last;
    } elsif (defined $oldSz) {
	my $est1 = $SECS*($tgtSz-$sz)/($sz-$oldSz);
	my $pred1 = localtime($now+$est1);
	my $est2 = ($now-$origTime)*($tgtSz-$sz)/($sz-$origSz);
	my $pred2 = localtime($now+$est2);
	printf(", predict end at %s\n",disjoinPhrases($pred1,$pred2));
    } else {
	print "\n";
    }
    $oldSz = $sz;
    unless (defined $origSz) {
	$origSz = $sz;
	$origTime = time();
    }
    sleep($SECS);
}

sub disjoinPhrases {
    my ($phr1,$phr2) = @_;
    return $phr1 if ($phr1 eq $phr2);
    my @a1 = split(" ",$phr1);
    my @a2 = split(" ",$phr2);
    return "$phr1 or $phr2" unless (@a1 == @a2);
    my $i=0;
    while ($i < $#a1 && $a1[$i] eq $a2[$i]) {
	$i++;
    }
    my $j = $#a1;
    while ($j > 0 && $a1[$j] eq $a2[$j]) {
	$j--;
    }
    return join(" ",
		@a1[0 .. $j],
		'or',
		@a2[$i .. $#a2]);
}

		
