#!/usr/bin/env perl

use Utility;
use strict;

# Args: dir with p?/*/alilines.nola.txt, and renamed.fastq file(s).

my ($dir,@files) = @ARGV;

my %aligned;
foreach my $f (glob("$dir/p?/*/alilines.nola.txt")) {
    my $fh = openToRead($f);
    while (<$fh>) {
	chomp;
	my (undef,$score,$read,undef,$lo,$hi) = split;
	if ($score == 0) {
	    # nothing
	} elsif ($lo < $hi) {
	    push @{$aligned{$read}},[$lo,$hi];
	} else {
	    push @{$aligned{$read}},[$hi,$lo];
	}
    }
}

my $read;
my @count;
my $nr;
foreach my $f (@files) {
    my $fh = openToRead($f);
    while (<$fh>) {
	chomp;
	if (/^\+(\S+) bases [1-9]/) {
	    $read = $1;
	} elsif ($read) {
	    my $len = length($_);
	    my @ali = defined $aligned{$read} ? @{$aligned{$read}} : ();
	    for (my $i=0; $i<$len; $i++) {
		my $q = ord(substr($_,$i,1))-33;
		while (@ali && $ali[0][1] < $i) {
		    shift @ali;
		}
		my $good = (@ali && $ali[0][0] <= $i);
		$count[$i][$q][$good] ++;
	    }
	    $read = undef;
	    $nr ++;
	    #last if ($nr == 1000);
	    #print STDERR "Done $nr reads\n" if ($nr%1000 == 0);
	}
    }
}

my (@countI,@countQ,@countI40);
foreach my $i (0 .. $#count) {
    my $pC = $count[$i];
    foreach my $q (0 .. $#$pC) {
	if (defined $pC->[$q]) {
	    printf("%d %d %d %d\n",$i,$q,$pC->[$q][0],$pC->[$q][1]);
	    $countI[$i][0] += $pC->[$q][0];
	    $countI[$i][1] += $pC->[$q][1];
	    if ($q >= 40) {
		$countI40[$i][0] += $pC->[$q][0];
		$countI40[$i][1] += $pC->[$q][1];
	    }
	    $countQ[$q][0] += $pC->[$q][0];
	    $countQ[$q][1] += $pC->[$q][1];
	}
    }
}
foreach my $i (0 .. $#countI) {
    if (defined @{$countI[$i]}) {
	printf("I %d %d %d\n",$i,$countI[$i][0],$countI[$i][1]);
    }
}
foreach my $i (0 .. $#countI40) {
    if (defined @{$countI40[$i]}) {
	printf("H %d %d %d\n",$i,$countI40[$i][0],$countI40[$i][1]);
    }
}
foreach my $q (0 .. $#countQ) {
    if (defined @{$countQ[$q]}) {
	printf("Q %d %d %d\n",$q,$countQ[$q][0],$countQ[$q][1]);
    }
}
