#!/usr/bin/env perl

# Input: output of possibleTransposonInsertions.pl

use Utility;
use strict;

my $WSZ = 10;
my $GAPSZ = 50;
my $MIN_N = 1;
my $TEL_SZ = 20000;

# First get chr sizes
my %CHRSZ;
my $fh = openToRead("$ENV{SGR}/ref/cere/genome.sz");
while (<$fh>) {
    chomp;
    my ($chr,$sz) = split;
    $CHRSZ{$chr} = $sz;
}

my %COUNT;
my %COUNT2;
while (<>) {
    chomp;
    my ($chr,$off,undef,$teId,$fc) = split;
    $chr =~ s/^REF\.//;
    $COUNT{$chr}{$off} ++;
    $COUNT2{$chr}{$off}{"$teId $fc"} ++;
}

my $gh = openToPipe("sort");
foreach my $chr (sort keys %COUNT) {
    my @offs = sort {$a <=> $b} keys %{$COUNT{$chr}};
    my (%nFrom,%maxCount,%maxMap);
    for (my $i=0; $i<=$#offs; $i++) {
	my $oi = $offs[$i];
	for (my $j=$i; $j<=$#offs && $offs[$j] < $oi+$WSZ; $j++) {
	    my $oj = $offs[$j];
	    my $c = $COUNT{$chr}{$oj};
	    $nFrom{$oi} += $c;
	    if ($c > $maxCount{$oi}) {
		$maxCount{$oi} = $c;
		$maxMap{$oi} = $oj;
	    }
	}
    }
    @offs = sort {$nFrom{$b} <=> $nFrom{$a}} @offs;
    foreach my $off (@offs) {
	if ($nFrom{$off} >= $MIN_N) {
	    my $off2 = $maxMap{$off};
	    if ($off2 >= $TEL_SZ && $off2 <= $CHRSZ{$chr}-$TEL_SZ) {
		my $pC2 = $COUNT2{$chr}{$off2};
		my @keys = sort {$pC2->{$b} <=> $pC2->{$a}} keys %$pC2;
		printf($gh "%s %7d %s %3d\n",$chr,$off2,$keys[0],$nFrom{$off});
		foreach my $off3 (@offs) {
		    if (abs($off3-$off) < $GAPSZ) {
			delete $nFrom{$off3};
		    }
		}
	    }
	}
    }
}

	    
