#!/usr/bin/env perl

use Utility;
use strict;

my (@low,@high,@mat,$ns);
while (<>) {
    chomp;
    my ($lo,$hi,$pat) = split(" ",$_,3);
    my @pres;
    my $iMax = length($pat)-2;
    for (my $i=2; $i<=$iMax; $i+=2) {
	push @pres,(substr($pat,$i,1) =~ /[AC]/ ? 1 : 0);
    }
    $ns = max($ns,scalar(@pres));
    push @low,$lo;
    push @high,$hi;
    push @mat,\@pres;
}
my $start = $low[0];
my $end = $high[-1];
my @events;
foreach my $j (0 .. $ns-1) {
    my $pr = 0;
    my $lo = $start;
    my (@lens,$lGap,$nGaps);
    foreach my $i (0 .. $#mat) {
	if ($mat[$i][$j] != $pr) {
	    if ($pr) {
		push @lens,[rand(),$low[$i]-$lo];
	    } else {
		$lGap += $low[$i]-$lo;
		$nGaps ++;
	    }
	    $lo = $low[$i];
	    $pr = $mat[$i][$j];
	}
    }
    if ($pr) {
	push @lens,[rand(),$end+1-$lo];
    } else {
	$lGap += $end+1-$lo;
	$nGaps ++;
    }
    # Divide lGap into nGaps segments
    my $avLen = $lGap/$nGaps;
    my ($sumGapLens,@gapLens);
    foreach my $i (1 .. $nGaps) {
	my $l = $avLen*log(1/rand());
	push @gapLens,$l;
	$sumGapLens += $l;
    }
    # Normalize gap lens
    my $fac = $lGap/$sumGapLens;
    foreach my $i (0 .. $#gapLens) {
	$gapLens[$i] = int(0.5+$gapLens[$i]*$fac);
    }
    # Sort lens at random
    @lens = sort {$a->[0] <=> $b->[0]} @lens;
    my $off = 1;
    if ($mat[0][$j]) {
	# start with content
	foreach my $i (0 .. $#lens) {
	    #printf("%d %d %d\n",$j,$off,$off+$lens[$i][1]-1);
	    push @events,[$off,$j,1];
	    push @events,[$off+$lens[$i][1],$j,0];
	    $off += $lens[$i][1]+$gapLens[$i];
	}
    } else {
	# start with gap
	$off += $gapLens[0];
	foreach my $i (0 .. $#lens) {
	    #printf("%d %d %d\n",$j,$off,$off+$lens[$i][1]-1);
	    push @events,[$off,$j,1];
	    push @events,[$off+$lens[$i][1],$j,0];
	    $off += $lens[$i][1]+$gapLens[$i+1];
	}
    }
}
@events = sort {$a->[0] <=> $b->[0] || $a->[1] <=> $b->[1] || $a->[2] <=> $b->[2]} @events;

my $off = 1;
my @pres;
foreach my $pEv (@events) {
    if ($pEv->[0] > 1) {
	printf("%d %d %s\n",$off,$pEv->[0]-1,presenceLine(\@pres));
    }
    $pres[$pEv->[1]] = $pEv->[2];
    $off = $pEv->[0];
}

sub presenceLine {
    my ($pPres) = @_;
    my $line;
    foreach my $v (@$pPres) {
	$line .= $v ? 'C ' : '  ';
    }
    return $line;
}

