#!/usr/bin/env perl

# zcat */layout.gz | grep '^>.* 0$' | pf : 1 | sed 's/.//' | sort -u > ~/iter000_reads.txt

use Utility;
use strict;

my %want;
my $fh = openToRead("$ENV{HOME}/iter000_reads.txt");
while (<$fh>) {
    chomp;
    $want{$_} = 1;
}

# Args: renamed.fastq files

my @COUNT;
while (1) {
    my @a;
    for (my $i=0; $i<4; $i++) {
	$a[$i] = <>;
    }
    last unless ($a[3]);
    my ($name) = split(" ",substr($a[2],1));
    if ($want{$name}) {
	delete $want{$name};
	foreach my $c (split("",$a[3])) {
	    my $q = ord($c)-33;
	    $COUNT[$q] ++;
	}
    }
}
my $sum;
foreach my $c (@COUNT) {
    $sum += $c;
}
my $tot=0;
my $ne=0;
foreach my $q (0 .. $#COUNT) {
    my $c = $COUNT[$q];
    if ($c) {
	$tot += $c;
	my $pe = min(0.5,exp(-$q*log(10)/10));
	$ne += $c*$pe;
	printf("%3d %8d %8.6f %10d %8.6f\n",
	       $q,$c,$c/$sum,$tot,$tot/$sum);
    }
}
printf("Mean error rate estimated as %10.8f\n",$ne/$tot);
