#!/usr/bin/env perl

# Args: alignment-line number and layout.gz file
# Prints reads current at target line, and their positions

use Utility;
use strict;

my ($tgt,$f) = @ARGV;

my @at;
my $fh = openToRead($f);
my $ln = 0;
while (<$fh>) {
    $ln ++;
    next if ($tgt-$ln > 20000);
    if (substr($_,0,1) eq '>') {
	if (/^>(\S+) (\d+) (\d+)$/) {
	    chomp;
	    $at[$2] = [$1,$3,$ln];
	}
    } else {
	chomp;
	my $len = length($_);
	for (my $i=0; $i<=$#at; $i++) {
	    if ($at[$i]) {
		my $col = 2*($i+1);
		if ($col >= $len || substr($_,$col,1) eq ' ') {
		    $at[$i] = undef;
		}
	    }
	}
    }
    if ($ln == $tgt) {
	foreach my $i (0 .. $#at) {
	    if ($at[$i]) {
		my $age = $tgt-$at[$i][2];
		if ($age <= 20000) {
		    printf("%2d %5d %2d %s\n",$i,$age,$at[$i][1],$at[$i][0]);
		}
	    }
	}
	last;
    }
}
