#!/usr/bin/env perl

use Utility;
use File::Basename;
use strict;

# Args: cere methc CERE

# Give output to filterLayoutByReads.pl

# Before running this, need to do e.g.

# cd $SGR/read
# sv -m */para/methc
# cd $SGR/match/PARA/para/methc
# sv -m of 0??/align/*/X for each X created by alip:
# alilines.pass.txt alilines.all.status.txt clusters.txt ssahaSNP.pass.gz 
# and then
# for i in 0??
#  do sgrp.pl -bf -i $i alip para methc PARA $PARA | tail -1
#  echo Done $i
#  done
# This discards about 0.7% of reads passed in iteration 0, in para.

my ($sp,$filt,$set) = @ARGV;

my $ROOT = $ENV{SGR};

my $top = "$ROOT/match/$set/$sp/$filt";

my @strains;
foreach my $d (glob("$top/001/align/*")) {
    push @strains,basename($d) if (-d $d);
}

foreach my $str (@strains) {
    my (%max1,%max2);
    foreach my $dir (glob("$top/[0-9][0-9][0-9]")) {
	my $iter = sprintf("%d",basename($dir));
	unless (-f "$dir/isExtraIteration") {
	    my $ad = "$dir/align";
	    my ($dd,$f1,$f2);
	    if ($iter == 0) {
		$dd = "$ROOT/read/$str/$sp/$filt";
		$f1 = "$dd.sv1/alilines.pass.txt";
	    } else {
		$dd =  "$ad/$str";
		$f1 = "$dd/alilines.pass.txt.sv1";
	    }
	    $f2 = "$dd/alilines.pass.txt";
	    if (-s $f1 && -s $f2) {
		my $fh = openToRead($f1);
		while (<$fh>) {
		    chomp;
		    my @a = split(" ",$_,4);
		    $max1{$a[2]} = $iter;
		}
		my $fh = openToRead($f2);
		while (<$fh>) {
		    chomp;
		    my @a = split(" ",$_,4);
		    $max2{$a[2]} = $iter;
		}
	    }
	}
    }
    foreach my $r (sort keys %max1) {
	if ($max1{$r} > $max2{$r} || !defined $max2{$r}) {
	    print "$r\n";
	}
    }
}
