#!/usr/bin/env perl

# Run from "align" dir

use Utility;
use Cwd;
use File::Basename;

use strict;

autoflush STDOUT 1;

my $cwd = cwd();
my @comps = split(/\//,$cwd);

my $sp = $comps[-4];
(my $sgr = $cwd) =~ s/\/match\/.*//;

foreach my $ss (glob("*/ssahaSNP.all.gz")) {
    my $str = dirname($ss);
    report("$ss: reading");
    my $fh = openToRead($ss);
    my %want;
    while (<$fh>) {
	if (/^Matches For/) {
	    chomp;
	    my @a = split;
	    $want{$a[-1]} = 1;
	}
    }
    report();
    report("$str/renamed.?.fastq: writing");
    foreach my $n (0 .. 9) {
	my $f = "$sgr/read/$str/renamed.$n.fastq";
	my $g = "$str/renamed.$n.fastq";
	next if (-s $g);
	unless (-s $f) {
	    die("Cannot find $f");
	}
	my $fh = openToRead($f);
	my $gh = openToWrite($g);
	while (<$fh>) {
	    my ($r) = split(" ",substr($_,1));
	    my $active = $want{$r};
	    my @quad = $_;
	    foreach my $i (0 .. 2) {
		my $line = <$fh>;
		push @quad,$line;
	    }
	    if ($active) {
		print $gh @quad;
	    }
	}
    }
    report();
}
