#!/usr/bin/env/perl

use Utility;
use strict;

foreach my $d (@ARGV) {
    removeAllGapLocations($d);
}

sub removeAllGapLocations {
    my ($d) = @_;
    return unless readyToRemoveGapLocations($d);
    

sub readyToRemoveGapLocations {
    my ($d) = @_;
    my $ok = 1;
    foreach my $b (qw(layout sorted imputed_m imputed_y)) {
	my $f = "$d/$b.gz";
	unless (-s $f && ! -f "$f.touch") {
	    report("$f: missing, empty or not ready",1);
	    $ok = 0;
	}
    }
    foreach my $b (qw(final_layout final_sorted final_imputed)) {
	if (-s $f || -f "$f.touch") {
	    report("$f: already present or being created",1);
	    $ok = 0;
	}
    }
    return $ok;
}
    
