#!/usr/bin/env perl

# Copy from layout.gz in arg1 to arg2 (iter dirs)

use Utility;
use strict;

removeVoidLines(@ARGV);

sub removeVoidLines {
    my ($srcDir,$tgtDir) = @_;
    unless (-d $srcDir && ! -d $tgtDir && @_ == 2) {
	die("Usage: $0 srcDir tgtDir, where only srcDir should exist");
    }
    foreach my $f (glob("$srcDir/p?/*/layout.gz")) {
	my $g = $f;
	substr($g,0,length($srcDir)) = $tgtDir;
	report("$g: creating");
	my $fh = openToRead($f);
	my $gh = openToWrite($g);
	while (<$fh>) {
	    if (/^>/) {
		print $gh $_;
		next;
	    } else {
		chomp;
		print $gh "$_\n" unless (isVoidLine($_));
	    }
	}
	report();
    }
}

sub isVoidLine {
    my ($line) = @_;
    my $iMax = length($line)-2;
    for (my $i=0; $i<=$iMax; $i+= 2) {
	return 0 if (substr($line,$i,1) =~ /[A-Za-z]/);
    }
    return 1;
}
