#!/usr/bin/env perl

# Inputs: chrNN.cere.ali file(s)

use strict;

my $MIN_SCORE = 100;
my $MIN_PERC = 92.5;
my $MIN_SUM = 10;
my $WIDTH = 10;

my %delta;
while (<>) {
    chomp;
    my (undef,$score,$chr,undef,$lo,$hi,undef,undef,undef,undef,$perc) = split;
    if ($score >= $MIN_SCORE && $perc >= $MIN_PERC) {
	#print "$_\n";
	foreach my $v ($lo,$hi) {
	    $delta{$chr}{$v-$WIDTH}++;
	    $delta{$chr}{$v+$WIDTH}--;
	}
    }
}
foreach my $chr (sort keys %delta) {
    my ($prev,$where); # previous value
    my $sum = 0;
    my $pH = $delta{$chr};
    foreach my $v (sort {$a <=> $b} keys %$pH) {
	$sum += $pH->{$v};
	if ($pH->{$v} > 0) { # going up ...
	    $where = $v;
	    $prev = $sum;
	} else { # going down ...
	    if ($prev >= $MIN_SUM) {
		print "$chr $where\n";
		$prev = 0;
	    }
	}
    }
    # At end, just in case:
    if ($prev >= $MIN_SUM) {
	print "$chr $where\n";
    }
}
