#!/usr/bin/env perl

# Args: oldSuf newSuf file1 file2 ...
# Use '.' for null Suf.

use strict;

if (@ARGV < 3) {
    die("Usage: $0 oldSuf newSuf file1 file2 ...");
}

my ($old,$new,@files) = @ARGV;

$old = '' if ($old eq '.');
$new = '' if ($new eq '.');

unless ($old ne '' || $new ne '') {
    die("Usage: $0 oldSuf newSuf file1 file2 ... where one of oldSuf and newSuf is not '.'");
}

my $len = length($old);

my $maxFLen = 0;
foreach my $f (@files) {
    my $lf = length($f);
    $maxFLen = $lf if ($maxFLen < $lf);
}

foreach my $f (@files) {
    $f =~ s/\/$//;
    my $ff = $f . ' ' x ($maxFLen-length($f));
    if (! -f $f && ! -d $f) {
	printf("%s not found\n",$ff);
    } elsif ($len && substr($f,-$len) ne $old) {
	printf("%s does not end in %s\n",$ff,$old);
    } else {
	my $g = $f;
	if ($len) {
	    substr($g,-$len) = $new;
	} else {
	    $g .= $new;
	}
	if (-f $g || -d $g) {
	    printf("%s not renamed as %s exists\n",$ff,$g);
	} else {
	    if (rename($f,$g)) {
		printf("%s renamed to %s\n",$ff,$g);
	    } else {
		printf("%s rename to %s FAILED\n",$ff,$g);
	    }
	}
    }
}
