#!/usr/bin/perl

# Args: [-m mafFile -t thPair] [-p pfx] mainDir hoDir

if [ -z "$1" ]
  then MAIN=methc09
  else MAIN=$1
fi

if [ -z "$2" ]
  then HELD=methc91
  else HELD=$2
fi

DIR=cia_chrs_${MAIN}_${HELD}

if [ ! -d $MAIN/p0 ]
  then
  NEWMAIN='';
  for dd in $MAIN/???
    do
    if [ -d $dd/p0 ]
      then NEWMAIN=$dd
    fi
    done
  if [ -d $NEWMAIN ]
    then MAIN=$NEWMAIN
    else echo Cannot find $MAIN/p0 or $MAIN/'???/p0'
         exit 1
  fi
fi

if [ $HELD = complete -a ! -d $HELD ]
  then HELD=`pwd | sed 's@\([0-9][0-9]*\)_[0-9]/freg@_COMPLETE/\1@'`
       #echo Current dir: `pwd`
       #echo New HELD is: $HELD
fi

if [ ! -d $HELD/p0 ]
  then echo Cannot find $HELD/p0
       exit 1
fi

CHRS=''
for d in $MAIN/p?/c*
  do
  if [ -s $d/sorted.gz ]
    then BASE=`basename $d`
         CHRS="$CHRS $BASE"
  fi
  done

if [ -n "$THR" ]
  then DIR="${DIR}_mac$THR"
fi

#sv -m $DIR
mkdir -p $DIR
for chr in $CHRS
  do
  BOUT=$DIR/cia.$chr.bout
  BERR=$DIR/cia.$chr.berr
  TOUCH=$DIR/cia.$chr.touch
  PART=`echo $chr | sed 's/.*\(.\)$/\1/' | sed 's/[^0-9]/0/'`
  CHRDIR=$MAIN/p$PART/$chr
  if [ -n "`grep -lw N1m $BOUT 2>/dev/null`" ]
    then echo $chr: already done
  elif [ -f $TOUCH ]
    then echo $chr: already doing
  elif [ -s $BERR ]
    then echo $chr: has errors
  elif [ ! -s $CHRDIR/${PFX}imputed.gz -o ! -s $CHRDIR/${PFX}imputeds.gz ]
    then echo $chr: not ready
    else rm -f $BOUT $BERR
         touch $TOUCH
         echo $chr: submitting
	 CMD="compareImputedAcross.pl $PFXSW $THRSW $MAIN $HELD $chr"
	 bsub -o $BOUT -e $BERR "$CMD; rm $TOUCH"
  fi
  done
