#!/usr/bin/env perl

use Utility;
use File::Basename;
use strict;

my $LSFP="/nfs/team71/phd/lh3/lsf-prog";
my $MAQ_PL="$LSFP/scripts/maq.pl";
chomp (my $ARCH = `arch`);
my $MAQ="$LSFP/${ARCH}-linux/maq";

my $RUN_DIR="/lustre/work1/sanger/lh3/lh3/work/yeast/run";

my $SGR = $ENV{SGR};

my $PAT = sprintf("%s-*",$ARGV[0] || "*"); # Arg should be cere or para

foreach my $raw (glob("$RUN_DIR/$PAT/raw")) {
    my ($sp,$str) = split(/-/,basename(dirname($raw)));
    $str =~ tr/-./__/;
    my $fa;
    (my $usp = $sp) =~ tr/a-z/A-Z/;
    my $ref = $sp eq 'cere' ? $str : 'REF';
    my $topDir = "$SGR/match/$usp/$sp/methc";
    my @subDirs = glob("$topDir/[0-9][0-9][0-9]");
    my $finalDir = $subDirs[-2];
    chdir($finalDir);
    my $extraDir = "../" . basename($subDirs[-1]);
    foreach my $f ("$extraDir/isExtraIteration",
		   "isFinalIteration") {
	unless (-f $f) {
	    die("$finalDir/$f: not found");
	}
    }
    my $fa = $ref eq 'REF' 
	? "$SGR/ref/$sp/genome.fa"
	: "$extraDir/assembly/$str/genome.fa";
    my $tgtDir = "solexa/$str";
    unless (-d $tgtDir) {
	mkdir_p($tgtDir);
	`$MAQ_PL easyrun -d $tgtDir $fa $raw/*.fastq.gz`;
	# We don't need this, as we only want the consensus file
	if (0) {
	    my $fh = openFromPipe("$MAQ mapview $tgtDir/all.map");
	    my $gh = openToWrite("$tgtDir/all.mapview.gz");
	    while (<$fh>) {
		my @a = split;
		print $gh $_ if ($a[6] >= 30);
	    }
	}
	# This replaces solexaAssembly.pl:
	my $fq = "$tgtDir.fastq.gz";
	report("$fq: creating");
	`$MAQ cns2fq $tgtDir/consensus.cns | gzip -c > $fq`;
	report();
    }
}
    
    

