#!/usr/bin/env perl

# Arg: layout.gz file

use Utility;
use strict;

my $fh = openToRead($ARGV[0]);
my ($line,$off) = (0,0);
my @ali;
while (<$fh>) {
    chomp;
    if (/^>/) {
	my ($read,$pos,$iter) = split(" ",substr($_,1));
	unless ($read eq 'REF') {
	    $ali[$pos] = [$read,$iter,$line,$off];
	}
    } else {
	$line ++;
	$off ++ if (/^[A-Z]/);
	my $i=2;
	my $iLim = length($_);
	my $r = substr($_,0,1);
	my $tran = ($r =~ /[a-z]/); # whether an augmented transposon
	$r = '-' if ($r eq '_' || $r eq '=' || $tran);
	foreach my $i (0 .. $#ali) {
	    my $pA = $ali[$i];
	    next unless ($pA);
	    if ($pA->[0] =~ /^S288c/) {
		my $k = ($i+1)*2;
		my $v = substr($_,$k,1);
		if ($v eq ' ' || $v eq '' || !defined $v) {
		    $ali[$i] = undef;
		} else {
		    $v =~ tr/a-z/A-Z/;
		    $v = '-' if ($v eq '_' || $v eq '=');
		    unless ($v eq $r) {
			printf("%7d %7d %s %s %s %d\n",
			       $line,$off,
			       substr($_,0,1),
			       substr($_,$k,2),join(" ",@$pA),$tran);
		    }
		}
	    }
	}
	my $iLim = length($_)/2;
	while ($#ali >= $iLim) {
	    pop @ali;
	}
    }
}
    
