#!/usr/bin/env perl

# -n N: want N reads (default 1 million)
# -o F: output results to file F (default STDOUT);
# Args: fastq file(s) to get reads from, or symlinks thereto

use Getopt::Std;
use Utility;
use strict;

my %OPT = qw(n 1000000);
getopts('n:o:',\%OPT);

my $nrWanted = $OPT{n};
my $gh = $OPT{o} ? openToWrite($OPT{o}) : *STDOUT;

my $nrSum = fastqReadCount(@ARGV);
while (1) {
    my $want = (rand()*$nrSum <= $nrWanted);
    if ($want) {
	foreach my $i (0 .. 3) {
	    $_ = <>;
	    print $gh $_;
	}
	$nrWanted --;
    } else {
	foreach my $i (0 .. 3) {
	    <>;
	}
    }
    $nrSum --;
}

sub fastqReadCount {
    my @files = @_;
    my $sum;
    foreach my $f (@ARGV) {
	$f = readlink($f) if (-l $f);
	my $fc = $f . 'check';
	my $fh = openToRead($fc);
	my $line = <$fh>;
	my ($nr) = split(" ",$line);
	$sum += $nr;
    }
    return $sum;
}
