#!/usr/bin/env perl

# Args: Spar_scaffolds.txssaha2 genome.fa
# ../cere/genome.fa -tags 1t, and output of

use Utility;
use strict;

scaffoldMatches(@ARGV);

sub scaffoldMatches {
    my ($sf,$mf) = @_;
    my $mh = openToRead($mf);
    my %alis;
    while (<$mh>) {
	if (/^ALIGNMENT/) {
	    chomp;
	    s/\sc0+(\d+)\s/ c\1 /;
	    my @a = split;
	    push @{$alis{$a[2]}},\@a;
	}
    }
    my $fh = openToRead($sf);
    my $curr;
    while (<$fh>) {
	chomp;
	if (/^s\d+\s/) {
	    my @a = split;
	    unless ($curr eq $a[0]) {
		print "\n";
		$curr = $a[0];
	    }
	    print $_;
	    my $pA = $alis{$a[2]};
	    for (my $i=0; $i<=2 && $i<=$#$pA; $i++) {
		my $pAli = $pA->[$i];
		printf("; %5s %5d %5d %6d %6d %s %s",@{$pAli}[3..8,10]);
	    }
	    print "\n";
	}
    }
}
