#!/usr/bin/env perl

# Args: sequence and .fa file(s)

use Utility;
use strict;

my $query = shift @ARGV;
foreach my $f (@ARGV) {
    $query =~ tr/a-z/A-Z/;
    search($query,$f);
}

sub search {
    my ($query,$f) = @_;
    my $fh = openToRead($f);
    my ($chr,$seq);
    my $rquery = reverse($query);
    $rquery =~ tr/ACGT/TGCA/;
    $seq = 'X'; # to get one-offset
    while (<$fh>) {
	chomp;
	if (/^>(\S+)/) {
	    search1($f,$chr,$seq,$query,$rquery);
	    $chr = $1;
	    $seq = "X";
	} else {
	    $seq .= $_;
	}
    }
    search1($f,$chr,$seq,$query,$rquery);
}

sub search1 {
    my ($f,$chr,$seq,$query,$rquery) = @_;
    return unless ($seq);
    $seq =~ tr/a-z/A-Z/;
    my $idx = -1;
    while (1) {
	my $idx1 = index($seq,$query,$idx+1);
	my $idx2 = index($seq,$rquery,$idx+1);
	if ($idx1 < 0) {
	    last if ($idx2 < 0);
	    my $end = $idx2+length($rquery)-1;
	    print "$f $chr $idx2 $end C\n";
	    $idx = $idx2;
	} elsif ($idx2 < 0 || $idx2 > $idx1) {
	    my $end = $idx1+length($query)-1;
	    print "$f $chr $idx1 $end F\n";
	    $idx = $idx1;
	} else {
	    my $end = $idx2+length($rquery)-1;
	    print "$f $chr $idx2 $end C\n";
	    $idx = $idx2;
	}	    
    }
}

	
