#!/usr/bin/env perl

# Run on output of qualityDistribution.pl

my $qMin = 40;

use strict;
my @cumul;
while (<>) {
    chomp;
    if (/^ *(\d+) /) {
	my ($q,$v) = split;
	$cumul[$q] = $v;
    }
}
my (@prop,@perr);
foreach my $i ($qMin .. $#cumul) {
    $prop[$i] = $cumul[$i]-$cumul[$i+1];
    $perr[$i] = exp(-$i*log(10)/10);
}

my $tot;
foreach my $i ($qMin .. $#cumul) {
    foreach my $j ($qMin .. $#cumul) {
	my $prop2 = $prop[$i]*$prop[$j];
	my $pe = $perr[$i]+$perr[$i]*(1-$perr[$i]);
	$tot += $pe*$prop2;
    }
}
$tot = $tot/($cumul[$qMin]*$cumul[$qMin]);
printf("Inflation = %12.10f\n",$tot);
