#!/usr/bin/env perl

use Utility;
use File::Basename;
use strict;

my %chrsz;
my $fh = openToRead("$ENV{SGR}/ref/cere/genome.sz");
while (<$fh>) {
    chomp;
    my ($chr,$sz) = split;
    $chrsz{$chr} = $sz;
}

foreach my $d (glob("$ENV{SGR}/read/*/cere_notext")) {
    my $str = basename(dirname($d));
    my $pGood = readGoodPairs("$ENV{SGR}/read/$str/renamed.wm");
    my $fh = openToRead("$d/alilines.all.txt");
    my $prev;
    my %ali;
    my %topScore;
    my %ambi;
    while (<$fh>) {
	chomp;
	my (undef,$score,$read,$chr,undef,undef,$lo,$hi,$fc) = split;
	#next if ($chr =~ /\.\d+$/);
	if ($read eq $prev) {
	    if ($score == $topScore{$read}) {
		delete $ali{$read};
		delete $topScore{$read}; # don't want ambiguous ones
		$ambi{$read} = 1;
	    } else {
		next;
	    }
	}
	$prev = $read;
	my $off = $fc eq 'F' ? $hi : $lo;
	$chr =~ s/^REF\.//;
	my $tel = ($chr =~ /^chr..$/ && ($off < 30000 || $off > $chrsz{$chr}-30000)) ? 'T' : 'N';
	$ali{$read} = "$chr $off $fc $tel";
	$topScore{$read} = $score;
    }	
    foreach my $ins (keys %$pGood) {
	my $ip = "$ins.p1k";
	my $iq = "$ins.q1k";
	next if ($ambi{$ip} || $ambi{$iq});
	if (defined $ali{$ip}) {
	    unless (defined $ali{$iq}) {
		my $v = $ali{$ip};
		print "$v $ins\n";
	    }
	} elsif (defined $ali{$iq}) {
	    my $v = $ali{$iq};
	    print "$v $ins\n";
	}
    }
}

sub readGoodPairs {
    my ($f) = @_;
    my $fh = openToRead($f);
    my %c;
    while (<$fh>) {
	chomp;
	my ($read,undef,$lo,$hi) = split;
	if ($hi) {
	    $read =~ s/\.[pq]1k$//;
	    $c{$read} ++;
	}
    }
    my %good;
    foreach my $name (keys %c) {
	$good{$name} = 1 if ($c{$name} > 1);
    }
    return \%good;
}
	
