#!/usr/bin/env perl

use Utility;
use strict;

autoflush STDOUT 1;

foreach my $d (@ARGV) {
    my $f = "$d/sorted.gz";
    sortedToDual($f,"$d/impm");
}

sub sortedToDual {
    my ($f,$d) = @_;
    return unless (-s $f);
    my $fh = openToRead($f);
    <$fh>; # discard header; we'll get them from the $if files
    report("creating $d/iNNN/dual_in");
    my $ni = 0;
    my ($ih,$gh);
    while (<$fh>) {
	unless (<$ih>) {
	    my $if = sprintf("%s/i%3d/imp_in",$d,$ni);
	    $if =~ tr/ /0/;
	    my $g = sprintf("%s/i%3d/dual_in",$d,$ni);
	    $g =~ tr/ /0/;
	    unless (-s $if) {
		print "missing $if ...";
		report();
		print "Input line was:\n$_";
		return;
	    }
	    if (-s $g) {
		print "already got $g ...";
		report();
		return;
	    }
	    $ih = openToRead($if);
	    $gh = openToWrite($g);
	    my $hdr = <$ih>;
	    print $gh $hdr;
	    $ni ++;
	    print ".";
	    <$ih>; # data line that we need
	}
	chomp;
	my $iMax = length($_)-2;
	for (my $i=0; $i<=$iMax; $i+=2) {
	    my $v = substr($_,$i,1);
	    if ($v eq '=') {
		$v = 'A'; # "absent"
	    } elsif ($v ne ' ') {
		$v = 'C'; # "chosen"
	    }
	    print $gh "$v ";
	}
	print $gh "\n";
    }
    report();
}
