#!/usr/bin/env perl

use Utility;
use strict;

foreach my $f (glob("*")) {
    unless (-d $f || $f =~ /\./) {
	splitMailByYear($f);
    }
}

sub splitMailByYear {
    my ($f) = @_;
    my $fh = openToRead($f);
    my @out;
    my $gh;
    while (<$fh>) {
	if (/^From /) {
	    my @a = split;
	    my $year = $a[-1];
	    chomp $year;
	    my $idx = $year-2000;
	    unless (defined $out[$idx]) {
		my $g = "$year/$f";
		if (-s $g) {
		    report("$g: already exists",1);
		    return;
		} else {
		    report("$g: creating",1);
		    $out[$idx] = openToWrite($g);
		}
	    }
	    $gh = $out[$idx];
	}
	print $gh $_;
    }
}

