#!/usr/bin/env perl

use Utility;
use strict;

my $CHUNK_SIZE = 100000;

foreach my $d (@ARGV) {
    splitRQPW($d);
}

sub splitRQPW {
    my ($d) = @_;
    my $f = "$d/rqpw.gz";
    my $g0 = "$d/rqpw000.gz";
    if (-s $f && stamp($g0)) {
	report("$d/rqpwNNN.gz etc: creating");
	splitRQPW1($f,$d);
	report();
	unstamp($g0);
    }
}

sub splitRQPW1 {
    my ($f,$d) = @_;
    my $n=0;
    my $gh = openRQPWChunk($d,$n);
    my $fh = openToRead($f);
    my $ln=0;
    my @anno;
    while (<$fh>) {
	print $gh $_;
	chomp;
	if (/^>(\S+) (\d+)/) {
	    $anno[$2] = $_ unless ($1 eq 'REF');
	} else {
	    my $col=2;
	    foreach my $i (0 .. $#anno) {
		if (defined $anno[$i] && substr($_,$col,1) !~ /[^ ]/) {
		    $anno[$i] = undef;
		}
		$col += 2;
	    }
	}
	$ln++;
	if ($ln == $CHUNK_SIZE) {
	    $ln=0;
	    $n++;
	    $gh = openRQPWChunk($d,$n);
	    foreach my $line (@anno) {
		if (defined $line) {
		    print $gh "$line\n";
		}
	    }
	}
    }
}

sub openRQPWChunk {
    my ($d,$n) = @_;
    my $g = sprintf("%s/rqpw%3d.gz",$d,$n);
    $g =~ tr/ /0/;
    return openToWrite($g);
}

