#!/usr/bin/perl

# Input: layout.gz file

use Utility;
use strict;

my $fh = openToRead($ARGV[0]);
my @using;
my ($off0,$off1);
while (<$fh>) {
    chomp;
    if (/^>REF /) {
	# nothing
    } elsif (/^>([^-:]+)-([^:]+):\d+:\d+ (\d+) /) {
	my ($str,$read,$k) = ($1,$2,$3);
	$using[$3] = [$1,$2];
    } else {
	if (/^[A-Z]/) {
	    $off0 ++;
	    $off1 = 0;
	} else {
	    $off1 ++;
	}
	my $kMax = length($_)/2-2;
	my %quals;
	for (my $k=0; $k<=$kMax; $k++) {
	    my $kk=($k+1)*2;
	    my $v = substr($_,$kk,1);
	    my $q = substr($_,$kk+1,1);
	    if ($v ne ' ' && $q ge 'I') {
		$v =~ tr/a-z/A-Z/;
		push @{$quals{$using[$k][0]}{$v}},[$q,$using[$k][1]];
	    }
	}
	foreach my $str (keys %quals) {
	    my $pH = $quals{$str};
	    my @vals = keys %$pH;
	    if (@vals > 1) {
		for (my $i=0; $i<$#vals; $i++) {
		    my $vi = $vals[$i];
		    for (my $j=$i+1; $j<=$#vals; $j++) {
			my $vj = $vals[$j];
			foreach my $pA1 (@{$pH->{$vi}}) {
			    foreach my $pA2 (@{$pH->{$vj}}) {
				printf("%d.%d %s-%s %s %s %s-%s %s %s\n",
				       $off0,$off1,
				       $str,$pA1->[1],$vi,$pA1->[0],
				       $str,$pA2->[1],$vj,$pA2->[0]);
			    }
			}
		    }
		}
	    }
	}
    }
	 }

