#!/usr/bin/perl

# Given an srf_manifest file, create a CSV showing 
#
# file name
# file size
# file mod time
# Seqs
# Len
# AvLen
# A,C,G,T percentages
# Average quality

use Utility;
use strict;

print "File,Day08,Size,Reads,Bases,AvLen,PercA,PercC,PercG,PercT,AvQual\n";
my $jan1 = 1199145600; # Start of Jan 1 2008
while (<>) {
    chomp;
    my $sra = $_;
    my $sz = -s $sra;
    my $mt = modTime($sra,1);
    (my $fqc = $_) =~ s/srf$/fastqcheck/;
    my @data;
    $data[7] = "";
    if (-s $fqc) {
	my $fh = openToRead($fqc);
	chomp (my $line = <$fh>);
	my ($seqs,undef,$len,undef,undef,$avLen) = split(" ",$line);
	<$fh>;
	<$fh>;
	chomp ($line = <$fh>);
	my (undef,$pa,$pc,$pg,$pt,@a) = split(" ",$line);
	my $aq = $a[-1];
	@data = ($seqs,$len,$avLen,$pa,$pc,$pg,$pt,$aq);
    }
    print join(",",$sra,int(($mt-$jan1)/86400),$sz,@data) . "\n";
}
