#!/usr/bin/env perl

# Input: output from
# ssaha2 queries.fa subject.fa -tags 1 -align 1 -best 2
# Output: (joint) best alignment line(s) for each query,
# suffixed with shortfall to next.

use strict;
my ($oldScore,$oldQuery,$oldLine,$nSeen);
while (<>) {
    next unless (/^ALIGNMENT /);
    chomp;
    my (undef,$score,$query) = split;
    if ($query eq $oldQuery) {
	my $sf = $oldScore-$score;
	print "$oldLine $sf\n" if ($nSeen == 1);
	if ($sf == 0) {
	    print "$_ $sf\n";
	}
	$nSeen ++;
    } else {
	if ($nSeen == 1) {
	    # there was only one alignment, so shortfall = score
	    print "$oldLine $oldScore\n";
	}
	$nSeen = 1;
	$oldScore = $score;
	$oldQuery = $query;
	$oldLine = $_;
    }
}
if ($nSeen == 1) {
    # there was only one alignment, so shortfall = score
    print "$oldLine $oldScore\n";
}
