#!/usr/bin/env perl

# Inputs: (1) cns.snp, and (2) output of ssahaPolymorphismsExtract.pl

use Utility;
use strict;

my $fh1 = openToRead($ARGV[0]);
my $fh2 = openToRead($ARGV[1]);

my ($cnsChr,$cnsOff,$cnsFrom,$cnsTo);
while (<$fh2>) {
    next if (/-/); # we don't do indels here
    chomp;
    my ($chr,$lo,$hi,$from,$to,$count) = split;
    next if ($from =~ /../ || $to =~ /../);
    $from = 'N' if ($from eq 'X');
    $to = 'N' if ($to eq 'X');
    while ($cnsChr lt $chr || ($cnsChr eq $chr && $cnsOff < $lo)) {
	my $cnsLine = <$fh1>;
	chomp $cnsLine;
	($cnsChr,$cnsOff,$cnsFrom,$cnsTo) = split(" ",$cnsLine);
    }
    my $status = 0; # not in cns
    if ($cnsChr eq $chr && $cnsOff == $lo) {
	if ($cnsFrom ne $from) {
	    die("Reference disagreement at $chr $lo");
	} elsif ($cnsTo ne $to) {
	    $status = 1; # present but different
	} else {
	    $status = 2; # full agreement
	}
    }
    print "$_ $status\n";
}
