#!/usr/bin/env perl
# Input: "MERGED", resulting from "sort -m *.poly > MERGED" after ssahaPolymorphismsAll
# Optional switch: "-d N" (default 5) for absolute difference (sum at both ends) that
# qualifies for "non-unique"

use Getopt::Std;
use strict;

my %OPT = (d => 5);
getopts('d:',\%OPT);
my $DTH = $OPT{d};

my @used;
while (<>) {
    my @a = split();
    shift @a unless ($a[0]);
    my ($chr,$lo,$hi) = @a;
    if ($chr eq $used[0]) {
	my $d1 = $lo-$used[1];
	my $d2 = $hi-$used[2];
	$d1 = -$d1 if ($d1 < 0);
	$d2 = -$d2 if ($d2 < 0);
	next if ($d1+$d2 <= $DTH);
    }
    print;
    @used = ($chr,$lo,$hi);
}
