#!/usr/bin/env perl

use Utility;
use strict;

# Args: sorted.gz files

my %cov;
foreach my $f (@ARGV) {
    report("reading $f");
    my $fh = openToRead($f);
    my $hdr = <$fh>;
    chomp $hdr;
    my @strains = ('REF',split(" ",substr($hdr,1)));
    my @c;
    while (<$fh>) {
	chomp;
	if (/^[A-Z]/) {
	    my $len = length($_);
	    my $i=0;
	    for (my $col=0; $col<$len; $col+=2) {
		$c[$i] ++ if (substr($_,$col,1) =~ /[A-Z]/);
		$i++;
	    }
	}
    }
    foreach my $i (0 .. $#c) {
	$cov{$strains[$i]} += $c[$i];
    }
    report();
}

my $cr = $cov{REF};
foreach my $s (sort keys %cov) {
    printf("%8d %5.3f %s\n",$cov{$s},$cov{$s}/$cr,$s);
}
