#!/usr/bin/env perl

use strict;

# Input: output of compareImputedAcross.pl with REPORT_MISMATCHES on

my ($bStart,$bPrev,$nPlaces,$sCount,@nMis);
while (<>) {
    chomp;
    my @a = split;
    if ($a[0] eq 'NSHO:') {
	my (undef,$chr,undef,$off,undef,$sc) = @a;
	if ($sCount > 0) {
	    # Continue block
	    $nPlaces += ($off-$bPrev)*$sCount;
	} else {
	    $bStart = $off;
	}
	$bPrev = $off;
	$sCount = $sc;
	if ($sc == 0) {
	    # End and report block
	    printf("Block %s %7d to %7d had %5d places, %3d %3d %3d",
		   $chr,$bStart,$off-1,$nPlaces,$nMis[1],$nMis[2],$nMis[3]);
	    printf(" %7.5f %7.5f %7.5f\n",
		   $nMis[1]/$nPlaces,
		   $nMis[2]/$nPlaces,
		   $nMis[3]/$nPlaces),
	    @nMis = ();
	    $bStart = 0;
	    $nPlaces = 0;
	}
    } elsif ($a[0] eq 'Mismatch:') {
	my $type = $a[7];
	$nMis[$type] ++;
    }
}
	
