#!/usr/bin/env perl

use Utility;
use Getopt::Std;
use strict;

my %OPT;
getopts('l:h:',\%OPT);

my $lo = $OPT{l} || 1;
my $hi = $OPT{h} || 1000000;

my %spOf;
my %c1;
my %c2;
foreach my $sp (qw(cere para)) {
    my $f = "${sp}IndelSpectrum.txt";
    my $fh = openToRead($f);
    while (<$fh>) {
	chomp;
	my ($str,$op,$len,$n) = split;
	if ($len >= $lo && $len <= $hi) {
	    $spOf{$str} = $sp;
	    my $b = int(log($len)/log(2));
	    $c1{$sp}{$op}[$b] += $len*$n;
	    $c2{$str}{$op} += $len*$n;
	}
    }
}
foreach my $sp (keys %c1) {
    my $cc = substr($sp,0,1);
    my $gh = openToWrite("siad_${cc}_${lo}_$hi.txt");
    printf($gh "%3s %2s %8s\n","op","b","nucs");
    foreach my $op (qw(ins del mch)) {
	my $pA = $c1{$sp}{$op};
	foreach my $i (0 .. $#$pA) {
	    printf($gh "%3s %2d %8d\n",$op,$i,$pA->[$i]);
	}
    }
}
my $ch = openToWrite("siad_cs_${lo}_$hi.txt");
printf($ch "%13s %3s %8s\n","str","op","nucs");
my $ph = openToWrite("siad_ps_${lo}_$hi.txt");
printf($ph "%13s %3s %8s\n","str","op","nucs");
foreach my $str (sort keys %c2) {
    foreach my $op (qw(ins del mch)) {
	my $n = $c2{$str}{$op};
	my $gh = $spOf{$str} eq 'cere' ? $ch : $ph;
	printf($gh "%13s %3s %8d\n",$str,$op,$n);
    }
}
