#!/usr/bin/env perl

use Utility;
use File::Basename;
use strict;

autoflush STDOUT 1;

my %COUNT;
my @files = @ARGV;
@files = glob("p?/chr??/imputed_z.gz") unless (@files);
foreach my $f (@files) {
    my %count; # for this file
    my $fh = openToRead($f);
    chomp (my $hdr = <$fh>);
    my @strains = ('REF',split(" ",substr($hdr,1)));
    my @c;
    while (<$fh>) {
	chomp;
	my $iLim = length($_);
	for (my $i=0; $i<$iLim; $i+=2) {
	    $c[$i]{substr($_,$i,1)} ++;
	}
    }
    foreach my $j (0 .. $#strains) {
	my $s = $strains[$j];
	my $pH = $c[2*$j];
	foreach my $sym (keys %$pH) {
	    my $n = $pH->{$sym};
	    $sym =~ tr/acgt/a/;
	    $sym =~ tr/_=/-/;
	    $sym =~ tr/acgtCGT/A/;
	    $count{$s}{$sym} += $n;
	    $COUNT{$s}{$sym} += $n;
	}
    }
    printTable(\%count,basename(dirname($f)));
}
printTable(\%COUNT,'chrNN');

sub printTable {
    my ($pCount,$chr) = @_;
    foreach my $s (sort keys %$pCount) {
	my $pH = $pCount->{$s};
	my $sum = 0;
	foreach my $v (values %$pH) {
	    $sum += $v;
	}
	printf("%s %13s %7d",$chr,$s,$sum);
	foreach my $sym (qw(A - N)) {
	    printf(" %s %12.10f",$sym,$pH->{$sym}/$sum);
	}
	print "\n";
    }
}
