#!/usr/bin/env perl

use Getopt::Std;
use strict;

my %OPT;
# Align and/or tag; default is tag only.
getopts('at',\%OPT);

my $align = $OPT{a};
my $tag = $OPT{t} || !$align;

my @mat;
my @maxLen;
while (<>) {
    chomp;
    my @a = split;
    foreach my $i (0 .. $#a) {
	my $l = length($a[$i]);
	$maxLen[$i] = $l if ($maxLen[$i] < $l);
    }
    push @mat,\@a;
}

foreach my $pA (@mat) {
    my $sep = "";
    foreach my $i (0 .. $#$pA) {
	my $val = $align ? sprintf("%$maxLen[$i]s",$pA->[$i]) : $pA->[$i];
	if ($tag) {
	    printf("%s%d:%s",$sep,$i,$val);
	} else {
	    printf("%s%s",$sep,$val);
	}
	$sep = " ";
    }
    print "\n";
}
