#!/usr/bin/env perl

use Utility;
use strict;

# On all chr??.gz files in multipleSpeciesAlignments, this gives:
#
# D(cere,para) = 0.14280590
# D(cere,baya) = 0.28127428
# D(para,baya) = 0.30331530


my @count;
foreach my $f (@ARGV) {
    report("$f: reading");
    my $fh = openToRead($f);
    while (<$fh>) {
	chomp;
	if (/^([A-Z]).([A-Z]).([A-Z])/) {
	    my ($cere,$para,$baya) = ($1,$2,$3);
	    $count[0][$para eq $baya] ++;
	    $count[1][$cere eq $baya] ++;
	    $count[2][$cere eq $para] ++;
	}
    }
    report();
}

my @annos = qw(para,baya cere,baya cere,para);
foreach my $k (2,1,0) {
    my $pair = $annos[$k];
    my $prop = $count[$k][0]/($count[$k][0]+$count[$k][1]);
    my $dist = -(3/4)*log(1-$prop*4/3);
    printf("D(%s) = %10.8f\n",$pair,$dist);
}
