#!/usr/bin/env perl

# Args: clip.wm file, then dirs with layout.gz files

use Utility;
use File::Basename;
use strict;

my ($clip,@dirs) = @ARGV;

my %map;
my $fh = openToRead($clip);
my $str;
while (<$fh>) {
    if (substr($_,0,1) eq '@') {
	chomp;
	my ($read,undef,$rlo,undef,$rhi,$where) = split(" ",substr($_,1));
	#my ($chr,$clo,$chi) = split(/:/,$where);
	$where =~ tr/:/ /;
	$map{$read} = $where;
	unless (defined $str) {
	    ($str) = split(/-/,$read);
	}
    }
}

foreach my $d (@dirs) {
    my $f = "$d/layout.gz";
    my $g = "$d/track.$str.txt";
    my $chr = basename($d);
    if (-f $f && ! -s $g) {
	report("$g: creating");
	my $fh = openToRead("$d/layout.gz");
	my $gh = openToWrite($g);
	my $off=0;
	while (<$fh>) {
	    chomp;
	    if (/^[A-Z]/) {
		$off ++;
	    } elsif (/^>/) {
		my ($readSpec) = split(/ /,substr($_,1));
		my ($read,$rlo,$rhi) = split(/:/,$readSpec);
		if (defined $map{$read}) {
		    print $gh "$chr $off $read $rlo $rhi $map{$read}\n";
		}
	    }
	}
	report();
    }
}
