#!/usr/bin/env perl

# Now part of SortLayoutFiles.pm

use Utility;
use strict;

foreach my $d (@ARGV) {
    unsequencedLocationCount($d);
}

sub unsequencedLocationCount {
    my ($d) = @_;
    my $f = "$d/sorted.gz";
    my $g = "$d/unsequenced.txt";
    return unless (-s $f && ! -f "$f.touch" && stamp($g));
    report("$g: creating");
    my ($nus,$nlocs) = unsequencedLocationCount1($f);
    my $gh = openToWrite($g);
    print $gh "$nus $nlocs\n";
    $gh->close();
    unstamp($g);
    report();
}

sub unsequencedLocationCount1 {
    my ($f) = @_;
    my $fh = openToRead($f);
    my $hdr = <$fh>;
    chomp $hdr;
    my @strains = split(" ",substr($hdr,1));
    my $ns = scalar(@strains);
    my $nus = 0;
    my $nl = 0;
    while (<$fh>) {
	if (/^[A-Z]/) {
	    my $len = length($_);
	    $nus += $ns;
	    for (my $i=2; $i<$len; $i+=2) {
		$nus -- unless (substr($_,$i,1) eq ' ');
	    }
	    $nl++;
	}
    }
    return ($nus,$nl*$ns);
}
