#!/usr/bin/env perl

use XML::Simple;

my %OPTS_IN = (KeepRoot => 1, ForceArray => 1, KeyAttr => []);
my %OPTS_OUT = (KeepRoot => 1, KeyAttr => []);

my $XML_HEADER = '<?xml version="1.0" encoding="UTF-8"?>';

my $XS = XML::Simple->new();

my $pXML = $XS->XMLin($ARGV[0],%OPTS_IN);
xmlToFile(xmlsort($pXML));

sub xmlsort {
    my ($pXML) = @_;
    my $ty = ref($pXML);
    if ($ty eq 'SCALAR') {
	return $pXML;
    } elsif ($ty eq 'ARRAY') {
	my @arr;
	foreach my $pSub (@$pXML) {
	    push @arr,xmlsort($pSub);
	}
	return [sort &xmlcmp @arr];
    } elsif ($ty eq 'HASH') {
	foreach my $key (sort keys %$pXML) {
	    $pXML->{$key} = xmlsort($pXML->{$key});
	}
	return $pXML;
    }
}

sub xmlToFile {
    my ($pXML,$file) = @_;
    my $gh = defined $file ? new FileHandle(">$file") : *STDOUT;
    print $gh "$XML_HEADER\n";
    print $gh $XS->XMLout($pXML,%OPTS_OUT);
    $gh->close() if (defined $file);
}
